Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu Feb 9 09:39:41 2023 +0100

    Release 3.7.9
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Tue Jan 3 09:06:01 2023 +0100

    Update year of copyright notices in doc/gnutls.texi
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Hubert Kario <hkario@redhat.com>
Date:   Wed Feb 8 14:43:45 2023 +0100

    document the CVE fix
    
    Signed-off-by: Hubert Kario <hkario@redhat.com>

Author: Hubert Kario <hkario@redhat.com>
Date:   Wed Feb 8 14:32:09 2023 +0100

    rsa: remove dead code
    
    since the `ok` variable isn't used any more, we can remove all code
    used to calculate it
    
    Signed-off-by: Hubert Kario <hkario@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Aug 9 16:05:53 2022 +0200

    auth/rsa: side-step potential side-channel
    
    Remove branching that depends on secret data.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>
    Signed-off-by: Hubert Kario <hkario@redhat.com>
    Tested-by: Hubert Kario <hkario@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Sep 21 14:56:49 2022 +0200

    Release 3.7.8
    
    Not bumping LT_CURRENT / LT_AGE since abi-check reports no changes.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Sep 21 14:26:55 2022 +0200

    NEWS: add an entry for allowlisting-relaxing functions restriction
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Sep 19 07:40:01 2022 +0900

    accelerated: avoid symbol export mismatch with _gnutls_x86_cpuid_s
    
    If the LD doesn't have support for version scripts,
    _gnutls_x86_cpuid_s is exported through libtool's
    --export-symbols-regex and that causes link error with clang:
    
      libtool: link: nmedit -s .libs/libgnutls-symbols.expsym .libs/libgnutls.30.dylib
      /Library/Developer/CommandLineTools/usr/bin/nmedit: error: symbols names listed in: .libs/libgnutls-symbols.expsym not in: /opt/local/var/macports/build/_Users_marius_Development_MacPorts_ports_devel_gnutls/gnutls-devel/work/gnutls-3.7.5/lib/.libs/libgnutls.30.dylib
      __gnutls_x86_cpuid_s
      make[4]: *** [libgnutls.la] Error 1
    
    This patch renames _gnutls_x86_cpuid_s to GNUTLS_x86_cpuid_s to avoid
    the issue.
    
    Problem investigated and fix suggested by Clemens Lang in:
    https://gitlab.com/gnutls/gnutls/-/issues/1370#note_967832583
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 18 17:38:46 2022 +0900

    compress-cert: support compression of client certificates
    
    Previously the compress_certificate extension was sent by the server
    as part of ServerHello, which violates RFC 8879.  This patch instead
    send it as an extension of CertificateRequest.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Fri Sep 9 13:32:16 2022 +0200

    Report system config file location via gnutls-cli
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Aug 20 11:06:07 2022 +0900

    src: request tls-exporter only when unique master secrets are used
    
    This is to comply with RFC9266 4.2.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Aug 29 06:41:46 2022 +0900

    gnutls_session_channel_binding: perform check on "tls-exporter"
    
    According to RFC9622 4.2, the "tls-exporter" channel binding is only
    usable when the handshake is bound to a unique master secret.  This
    adds a check whether either TLS 1.3 or extended master secret
    extension is negotiated.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Aug 20 10:58:23 2022 +0900

    doc: mention GNUTLS_CB_TLS_EXPORTER
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Doug Nazar <nazard@nazar.ca>
Date:   Tue Aug 16 01:47:49 2022 -0400

    cipher: Ensure correct alignment
    
    Unsigned math is required to calculate the current alignment.
    
    Signed-off-by: Doug Nazar <nazard@nazar.ca>

Author: Tobias Heider <tobias.heider@canonical.com>
Date:   Tue Aug 23 13:47:38 2022 +0200

    Unload custom allocators in gnutls_crypto_deinit()
    
    Closes #1398
    
    Signed-off-by: Tobias Heider <tobias.heider@canonical.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Aug 15 09:39:18 2022 +0900

    accelerated: clear AVX bits if it cannot be queried through XSAVE
    
    The algorithm to detect AVX is described in 14.3 of "Intel® 64 and IA-32
    Architectures Software Developer’s Manual".
    
    GnuTLS previously only followed that algorithm when registering the
    crypto backend, while the CRYPTOGAMS derived SHA code assembly expects
    that the extension bits are propagated to _gnutls_x86_cpuid_s.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Aug 18 09:01:20 2022 +0900

    srptool: resurrect default value for -i
    
    The default option value for -i (--index) was dropped during the
    cligen conversion.  This adds it back for compatibility with the
    existing command line usage.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Aug 18 09:00:44 2022 +0900

    cligen: update git submodule
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Aug 16 10:34:05 2022 +0200

    tests: add fips-rsa-sizes
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Feb 16 14:36:48 2022 +0100

    update documentation on allowlisting API
    
    (in a separate commit so that it's easier to compare)
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Feb 16 14:28:18 2022 +0100

    plumb allowlisting API through the config, restrict usage to early times
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Martin Storsjo <martin@martin.st>
Date:   Mon Aug 15 23:50:16 2022 +0300

    windows: Avoid -Wint-conversion errors
    
    Clang 15 made "incompatible pointer to integer conversion" an error
    instead of a plain warning. This fixes errors like these:
    
    system/keys-win.c:257:13: error: incompatible pointer to integer conversion initializing 'HCRYPTHASH' (aka 'unsigned long') with an expression of type 'void *' [-Wint-conversion]
            HCRYPTHASH hHash = NULL;
                       ^       ~~~~
    
    Signed-off-by: Martin Storsjo <martin@martin.st>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Feb 15 16:26:52 2022 +0100

    lib/priority: extract parts of cfg_apply into cfg_*_set_array*
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Feb 14 18:00:25 2022 +0100

    lib/priority: move sigalgs filtering to set_ciphersuite_list
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Aug 3 16:39:47 2022 +0900

    nettle: mark RSA SigVer operation approved for known modulus sizes
    
    SP800-131A rev2 suggests certain RSA modulus sizes under 2048
    bits (1024, 1280, 1536, and 1792) may continue to be used for
    signature verification but not for signature generation.  This loosen
    the current service indicator report to approve them.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Aug 9 12:55:04 2022 +0900

    nettle: check RSA modulus size in bits rather than bytes
    
    Previously we checked RSA modulus size clamped to byte unit instead of
    bits.  This makes the check stricter by explicitly calculating the
    modulus size in bits.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Aug 9 12:08:24 2022 +0200

    fips: disable GNUTLS_CIPHER_3DES_CBC self-test
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Aug 8 13:54:13 2022 +0900

    .gitlab-ci.yml: mark all CI jobs interruptible
    
    This allows previous pipelines to be cancelled if a new job is
    submitted subsequently:
    https://docs.gitlab.com/ee/ci/yaml/#interruptible
    
    Suggested-by: Zoltán Fridrich <zfridric@redhat.com>
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Stanislav Zidek <szidek@redhat.com>
Date:   Mon Aug 8 23:07:21 2022 +0200

    Moved TLS interoperability tests to submodule.
    
    Signed-off-by: Stanislav Zidek <szidek@redhat.com>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Sun Jul 31 10:28:15 2022 +0200

    Avoid &> redirection bashism in testsuite
    
    Broken by 7b700dbcd5907944a7dd2f74cd26ad8586cd4bac
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Stanislav Zidek <szidek@redhat.com>
Date:   Thu Feb 11 13:57:27 2021 +0100

    interoperability testing with openssl
    
    GitLab CI extended to run 2way interoperability tests with openssl on
    Fedora. Also prepared for adding further interoperability tests once
    they are in better shape.
    
    Signed-off-by: Stanislav Zidek <szidek@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Aug 4 16:37:51 2022 +0900

    _gnutls_decrypt_pbes1_des_md5_data: use public crypto API
    
    This is a follow-up of e7f9267342bc2231149a640163c82b63c86f1dfd.  In
    the decryption code path with PBES1, algorithm checks for FIPS was not
    applied, because it used internal functions that bypass those checks.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Simon Josefsson <jas@josefsson.org>
Date:   Sat Jul 30 21:06:42 2022 +0200

    Update doc for GNUTLS_CB_TLS_EXPORTER towards RFC9266.
    
    Signed-off-by: Simon Josefsson <simon@josefsson.org>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Fri Jul 29 10:38:42 2022 +0200

    KTLS: hotfix
    
    session->internals.pull_func is set to system_read during gnutls_init()
    so check for user set pull/push function added in commit mentioned
    bellow will never pass.
    
    source: 2d3cba6bb21acb40141180298f3924c73c7de8f8
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu Jul 28 12:49:59 2022 +0200

    Release 3.7.7
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jul 26 11:39:57 2022 +0900

    socket: only set pull/push functions when --save-*-trace is used
    
    This allows gnutls-cli to use KTLS for the transport, unless either
    --save-client-trace or --save-server-trace is used.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jul 26 11:38:41 2022 +0900

    handshake: do not enable KTLS if custom pull/push functions are set
    
    If gnutls_transport_set_pull_function or
    gnutls_transport_set_push_function is used, we can't assume the
    underlying transport handle is an FD.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Fri Jul 22 12:00:11 2022 +0200

    Fix double free during gnutls_pkcs7_verify
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jul 27 20:23:26 2022 +0900

    guile: revert gnutls/build/tests.scm to use use-modules
    
    This partially reverts e727eb7901a3f1754de970c8529925ae3d591b90.  For
    some reason, the usage of #:use-module causes some behavioral
    difference that affects reauth.scm test.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Mon Jul 25 16:07:54 2022 +0200

    Fix memory leak in gnutls_pkcs7_import
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jul 14 15:19:23 2022 +0900

    crypto-api: add block cipher API with automatic padding
    
    This adds a couple of functions gnutls_cipher_encrypt3 and
    gnutls_cipher_decrypt3, which add or remove padding as necessary if
    the length of the plaintext is not a multiple of the block size.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jul 22 11:54:29 2022 +0900

    tests: temporarily disable checking against unresolvable hosts
    
    *.dane.verisignlabs.com and fedoraproject.org are no longer
    resolvable.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jul 20 15:00:10 2022 +0900

    src: add __attribute__((malloc)) to safe_open_rw
    
    This silences -Wsuggest-attribute=malloc warning with GCC 12.  While
    we could use ATTRIBUTE_DEALLOC(fclose, 1), it is currently not
    possible to use it until Gnulib is updated.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jul 20 14:54:48 2022 +0900

    src: add NULL check on return value of realloc used in tests
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jun 30 21:24:23 2022 +0900

    tests: resume-with-previous-stek: initialize session data
    
    Spotted by gcc-analyzer 12.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jun 30 21:23:31 2022 +0900

    tests: add __attribute__((__noreturn__)) to _fail and fail_ignore
    
    To suppress warnings with gcc-analyzer 12.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jun 30 21:13:53 2022 +0900

    crypto-selftests: fix decryption check condition in test_cipher_aead
    
    Spotted by gcc-analyzer 12.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jun 30 20:57:30 2022 +0900

    x509, tpm2: use asn1_node instead of deprecated ASN1_TYPE
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Sun Jul 10 23:41:26 2022 +0200

    guile: Allow session record ports to have a 'close' procedure.
    
    This addition makes it easy to close the backing file descriptor or port
    of a session when its record port is closed.
    
    * guile/src/core.c (SCM_GNUTLS_SESSION_RECORD_PORT_SESSION): Add SCM_CAR.
    (SCM_GNUTLS_SESSION_RECORD_PORT_CLOSE_PROCEDURE)
    (SCM_GNUTLS_SET_SESSION_RECORD_PORT_CLOSE)
    (SCM_GNUTLS_SESSION_RECORD_PORT_P)
    (SCM_VALIDATE_SESSION_RECORD_PORT): New macros.
    (make_session_record_port): Change "stream" argument to a pair.
    (close_session_record_port): New function.
    (scm_gnutls_session_record_port): Add optional 'close' parameter and
    honor it.
    (scm_gnutls_set_session_record_port_close_x): New function.
    (scm_init_gnutls_session_record_port_type): Add call to
    'scm_set_port_close' and 'scm_set_port_needs_close_on_gc'.
    * guile/tests/session-record-port.scm: Test it.
    * NEWS: Update.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Sun Jul 10 17:03:03 2022 +0200

    guile: Remove support for the 1.8.x series.
    
    The last Guile 1.8.x release dates back to 2010.
    
    * configure.ac: Remove 1.8 from 'GUILE_PKG'.
    * doc/gnutls-guile.texi (Guile Preparations): Remove mention of Guile 1.8.
    * guile/src/core.c (mark_session_record_port)
    (free_session_record_port): Remove.
    (scm_init_gnutls_session_record_port_type): Remove corresponding
    'scm_set_port_mark' and 'scm_set_port_free' calls.
    * guile/modules/gnutls.in: Remove top-level 'cond-expand' forms for
    Guile 1.8.
    * guile/modules/gnutls/build/tests.scm: Likewise.
    * NEWS: Update.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Sun Jul 10 17:02:17 2022 +0200

    maint: Update guile.m4.
    
    * m4/guile.m4: Update from Guile 3.0.7.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Brad Smith <brad@comstyle.com>
Date:   Fri Jul 15 22:44:03 2022 -0400

    accelerated: aarch64: add OpenBSD/aarch64 support
    
    Signed-off-by: Brad Smith <brad@comstyle.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jun 27 11:14:50 2022 +0900

    cipher: limit plaintext length supplied to AES-GCM
    
    According to SP800-38D 5.2.1.1, input data length of AES-GCM
    encryption function must be less than or equal to 2^39-256 bits.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Sun Jul 10 18:54:54 2022 +0200

    guile: Session record port treats premature termination as EOF.
    
    * guile/src/core.c (do_fill_port) [USING_GUILE_BEFORE_2_2]: Treat
    GNUTLS_E_PREMATURE_TERMINATION as EOF.
    (read_from_session_record_port) [!USING_GUILE_BEFORE_2_2]: Likewise.
    * guile/tests/premature-termination.scm: New file.
    * guile/Makefile.am (TESTS): Add it.
    * NEWS: Update.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Richard Costa <richard.costa@suse.com>
Date:   Sat Jul 9 00:50:21 2022 +0000

    Add self-test code inside a FIPS context
    
    Self-test code exercise lots of different FIPS-related code with
    side-effects. So, in order to prevent it from losing information when
    executing inside another context, we create an appropriated one.
    
    If the self-test fails, then the library is placed in error state, so it
    doesn't matter for other contexts.
    
    Signed-off-by: Richard Maciel Costa <richard.costa@suse.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Tue May 10 15:20:45 2022 +0200

    Increase the limit of TLS PSK usernames from 128 to 65535 characters
    
    Co-authored-by: Hannes Reinecke <hare@suse.de>
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 1 08:04:57 2022 +0200

    fips: make service indicator logging louder
    
    Previously, the only way to monitor the FIPS context transtion was to
    increase logging level to debug (2), which produces unrelated output.
    
    This changes the minimum logging level to audit (1) for when the
    transition happens.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jun 27 09:29:13 2022 +0900

    nettle: restrict output size of HKDF-Expand to 255 * HashLen
    
    RFC 5869 2.3 requires that requested output length of HKDF-Expand to
    be equal to or less than 255 times hash output size.
    
    Inspired by the report by Guido Vranken in:
    https://lists.gnupg.org/pipermail/gcrypt-devel/2022-June/005328.html
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Jun 28 17:22:36 2022 +0200

    tests/fips-test: minor extension
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 28 13:46:44 2022 +0900

    .gitlab-ci.yml: add fedora-ktls pipeline
    
    This is to ensure that the same testsuite succeeds even if we compile
    the library with --enable-ktls and KTLS is enabled with a run-time
    configuration.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 28 10:53:55 2022 +0900

    ktls: _gnutls_ktls_enable: fix GNUTLS_KTLS_SEND calculation
    
    Previously, if the first setsockopt for GNUTLS_KTLS_RECV fails and the
    same socket is used for both sending and receiving, GNUTLS_KTLS_SEND
    was unconditionally set.  This fixes the conditions and also adds more
    logging.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 28 10:23:33 2022 +0900

    handshake: do not reset KTLS enablement in gnutls_handshake
    
    As gnutls_handshake can be repeatedly called upon non-blocking setup,
    we shouldn't try to call setsockopt for KTLS upon every call.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 28 09:37:22 2022 +0900

    tests: enable KTLS config while running gnutls_ktls test
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Gregor Jasny <gjasny@googlemail.com>
Date:   Tue Jun 21 11:18:16 2022 +0200

    README.md: explicitly install libtasn1-bin
    
    Signed-off-by: Gregor Jasny <gjasny@googlemail.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Tue Jun 14 16:16:11 2022 +0200

    KTLS: disable by default enable by config
    
    KTLS will be disabled by default when build with `--enable-ktls` to
    enable it, use config file option `ktls = true` in [global] section.
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 3 15:43:00 2022 +0900

    fips: provide function to manually run FIPS self-tests
    
    FIPS140-3 IG 10.3.E Periodic Self-Testing says:
    
      At security levels 1 and 2, acceptable means for initiating the
      periodic self-tests include a provided service, resetting, rebooting
      or power cycling.
    
    Neither resetting, rebooting, nor power-cycling is suitable because
    those involve operations outside of the module.  Therefore this patch
    adds a new API to manually run the substance of FIPS140 self-tests.
    
    Suggeested by Richard Costa and Stephan Mueller in:
    https://gitlab.com/gnutls/gnutls/-/issues/1364
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed May 18 15:38:21 2022 +0200

    tests/suite/tls-fuzzer: remove most of the -n limiters...
    
    ... since tlsfuzzer now sets reasonable (~<10s/script) limits
    for most of the scripts by default
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed May 18 13:41:18 2022 +0200

    tests/suite/tls-fuzzer: pin current error messages with -X
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun May 29 10:54:48 2022 +0900

    build: Revert "Disable test scripts on windows"
    
    This reverts commit d2b99e3b3429e9b9a6fbff46598fd4c6a0910f65.
    
    It turned out that the test failures under mingw were caused by a
    regression in wine 7.5, possibly:
    https://bugs.winehq.org/show_bug.cgi?id=52743
    
    Now that the latest wine package based on wine 7.9 has no issues with
    running those test scripts, this enables them again in the build
    process.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Fri May 27 09:17:55 2022 +0200

    Release 3.7.6
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Asad Mehmood <asad78611@googlemail.com>
Date:   Mon May 23 14:35:46 2022 +0000

    libdane: fix typo in Makefile.am
    
    Signed-off-by: Asad Mehmood <asad78611@googlemail.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Fri May 13 14:37:05 2022 +0200

    Add release steps for windows builds
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Wed May 18 11:43:26 2022 +0200

    Fix out-of-bounds memcpy in gnutls_realloc_zero()
    
    Co-authored-by: Tobias Heider <tobias.heider@canonical.com>
    Co-authored-by: Daiki Ueno <ueno@gnu.org>
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu May 19 10:27:51 2022 +0200

    Disable test scripts on windows
    
    This is a temporary solution to avoid failures
    of test scripts when ran on windows
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu May 12 10:38:23 2022 +0200

    Release 3.7.5
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 10 09:52:26 2022 +0200

    cligen: update git submodule
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Fri Apr 29 12:28:50 2022 +0200

    Improve certificate sanity checks
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Tim Kosse <tim.kosse@filezilla-project.org>
Date:   Mon Mar 28 17:49:22 2022 +0200

    Fix psk_ke_modes_recv_params() wrongly setting HSK_PSK_KE_MODE_INVALID
    
    If the preferred side (as per session->internals.priorities->server_precedence)
    only supports one algorithm and if it is not the first in the other side's list
    of algorithms, then psk_ke_modes_recv_params did wrongly set
    session->internals.hsk_flags to HSK_PSK_KE_MODE_INVALID.
    
    Fixes #1303
    
    This issue was originally discovered while analyzing
    https://forum.filezilla-project.org/viewtopic.php?t=54333
    
    Signed-off-by: Tim Kosse <tim.kosse@filezilla-project.org>
    Co-authored-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat May 7 10:07:01 2022 +0200

    tests/cmocka-common.h: include <stdarg.h> before <cmocka.h>
    
    As documented in <https://api.cmocka.org/group__cmocka.html#details>,
    <stdarg.h> must be included before <cmocka.h>.
    
    Suggested by Brad Smith in:
    https://gitlab.com/gnutls/gnutls/-/issues/1360
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 29 12:01:53 2022 +0200

    configure.ac: check if compiler supports -Wa,-march=all
    
    Clang from LLVM 13.0.0 caused a segumentation fault if an unknown
    architecture is supplied through -march.  While this has been fixed in
    13.0.1, until it is widely deployed this adds a configure check as a
    safeguard:
    https://github.com/llvm/llvm-project/commit/d31f8cc6884ba3cc3e088fd57c4c533868e8a8b2
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jan 15 11:27:20 2022 +0100

    gnutls_aead_cipher_set_key: new function
    
    This adds gnutls_aead_cipher_set_key, which enables to reuse the same
    handle but reset the context and key, without releasing the memory.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jan 17 11:48:39 2022 +0100

    crypto-api: support AES-SIV with scatter-gather API
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jan 17 11:17:46 2022 +0100

    crypto-api: refactor iov_store_st operations
    
    This replaces copy_from_iov to more generic append_from_iov.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jan 17 10:36:44 2022 +0100

    crypto-api: split scatter-gather AEAD implementation to helper funcs
    
    These _encryptv, _encryptv2, and _decryptv2 functions take orthogonal
    code paths depending on whether the underlying AEAD implementation
    supports message based API.  This patch split the implementation to
    dedicated helper functions.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jan 17 10:07:02 2022 +0100

    crypto-api: add integer overflow checks around copying IOV
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu May 5 12:10:46 2022 +0200

    Extend fipshmac to take a path to libgnutls.so
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed May 4 15:27:16 2022 +0200

    .github/workflows/macos.yml: display tests/cert-tests/*.log
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed May 4 15:23:49 2022 +0200

    lib/fips.c: suppress -Wdiscarded-qualifiers warning
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed May 4 15:22:16 2022 +0200

    .gitignore: ignore tests/tls13/compress-cert*
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed May 4 15:19:17 2022 +0200

    tests/cert-tests/pkcs12.sh: use portable sed invocations
    
    The BSD sed doesn't recognize '\|' as the alternative operator, and
    the last '}' must be preceded with a newline.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Sep 21 08:07:25 2021 +0200

    tls: add flag to disable session ticket in TLS 1.2
    
    The existing GNUTLS_NO_TICKETS flag affects all versions of TLS, where
    PFS is assured in TLS 1.3, while it is not in TLS 1.2.  This adds a
    new flag GNUTLS_NO_TICKETS_TLS12 to allow applications to disable
    session tickets only in TLS 1.2.
    
    As the only means of resumption in TLS 1.3 is using session tickets,
    we could repurpose the GNUTLS_NO_TICKETS flag make it no-op in TLS
    1.3.  However it would break backward compatibility, so we defer it to
    the next major release.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Nov 28 11:31:30 2021 +0100

    session_ticket: avoid invalid free on error path
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Sep 21 11:08:06 2021 +0200

    _gnutls_version_max: return NULL if priorities are not populated
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 2 07:41:12 2022 +0200

    m4: update from autoconf-archive
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 17 10:56:35 2022 +0200

    .github/workflows/macos.yml: pull in gtk-doc
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu Apr 28 12:17:16 2022 +0200

    gnutls-cli, gnutls-serv: print supported channel binding
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Sep 4 07:16:18 2021 +0200

    .gitlab-ci.yml: replace valgrind checks with ASan
    
    Running the full test suite under valgrind wastes a lot of time and
    may cause intermittent failures due to timeout.  We have them mainly
    for VALGRIND_MAKE_MEM_UNDEFINED client request, though the ASan tests
    now cover the equivalent after
    f23c3a6cba43706a6ebb3f9b0018cd658dcc0a72.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu Apr 14 11:29:26 2022 +0200

    Use packit to automate fedora upstream release
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
Date:   Sun Apr 24 17:03:18 2022 +0900

    Preserve mbuffer type when linearized
    
    Signed-off-by: Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>

Author: Brian Wickman <bwickman97@outlook.com>
Date:   Thu Apr 21 05:52:36 2022 +0000

    Fix for #1132

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Apr 11 14:00:16 2022 +0200

    .gitignore: ignore files generated by asn1Parser
    
    These files are no longer maintained in the repository, after commit
    16061937.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 8 10:23:51 2022 +0200

    cligen: update git submodule
    
    This also reverts commit fd0e28a3 and changes how the cligen python
    files are included in the distribution.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Tue Apr 12 16:34:52 2022 +0200

    Small fips-test refactoring
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Mon Apr 11 16:04:38 2022 +0200

    Add zeroization of some critical security parameters
    to comply with FIPS-140-3 requirements
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Sun Apr 10 13:22:22 2022 +0200

    Document C++ soname bump in NEWS.
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Wed Mar 30 18:26:36 2022 +0200

    Add missing gtk-doc for GNUTLS_COMP_BROTLI/ZSTD.
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Wed Mar 30 18:18:12 2022 +0200

    Add missing copyright header
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Tue Apr 5 16:28:41 2022 +0200

    Add missing FIPS service indicator transitions
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Wed Apr 6 15:33:32 2022 +0200

    Remove 3DES from FIPS approved algorithms.
    According to the section 2 of SP800-131A Rev.2, 3DES algorithm
    will be disallowed for encryption after December 31, 2023:
    https://csrc.nist.gov/publications/detail/sp/800-131a/rev-2/final
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Fri Apr 1 12:34:12 2022 +0200

    Mark HKDF and AES-GCM as approved when used in TLS
    
    Co-authored-by: Pedro Monreal <pmgdeb@gmail.com>
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Mar 31 15:50:51 2022 +0200

    bootstrap.conf: use install-sh to copy cligen files
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Mar 19 10:01:09 2022 +0100

    lib/{gnutls,pkix}_asn1_tab.c: remove autogenerated files
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Mar 19 10:00:08 2022 +0100

    devel/README-ci.freebsd.md: stop mentioning autogen
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Mar 19 09:59:58 2022 +0100

    .github/workflows/macos.yml: stop installing autogen
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Mar 19 09:53:54 2022 +0100

    configure.ac: always assume GTK_DOC_CHECK macro
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Mar 31 14:28:32 2022 +0200

    fips: simplify library integrity checking
    
    This removes code duplication by grouping the path and hmac fields in
    hmac_file structure.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu Mar 31 10:13:06 2022 +0200

    Increase length limit of PKCS#12 passwords
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Fri Mar 25 11:31:05 2022 +0100

    ktls config documentation
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Benjamin Herrenschmidt <benh@kernel.crashing.org>
Date:   Thu Mar 31 08:57:07 2022 +1100

    Fix off-by one exit condition in pkcs#11 priv keys lookup
    
    In function find_privkeys(), the list-> array is allocated to be of size
    lists->key_ids_size. "current" is the index where the next found key will
    be written (starts at 0).
    
    The current exit condition is thus incorrect:
    
                    if (current > list->key_ids_size)
                            break;
    
    This will allow "current" to be equal to list->key_ids_size which will
    potentially cause an overflow if more keys are returned by the loop than
     was originally found when calculating that size.
    
    This is very unlikely, but incorrect nonetheless.
    
    Fix this by using the more classic construct of testing for the array bound
    in the loop exit condition, as suggested by Daiki Ueno.
    
    Signed-off-by: Benjamin Herrenschmidt <benh@kernel.crashing.org>

Author: Benjamin Herrenschmidt <benh@kernel.crashing.org>
Date:   Mon Mar 21 13:45:11 2022 +1100

    Fix matching of last key of a pkcs#11 token
    
    Retrieving the cert for the last key of a token fails due to an
    off-by-one bug in find_privkeys():
    
    In the loop that iterates the keys, "current" contains the index
    of the "next" key slot, which is also the active "count" of populated
    slots in the output struct find_pkey_list_st.
    
    The current statement:
    
            list->key_ids_size = current - 1;
    
    Means we return a "key_ids_size" of the current count minus one, ie 0
    for 1 key etc... However, this isn't what the callers expect, for example:
    
    find_multi_objs_cb() does:
    
                    ret = find_privkeys(sinfo, tinfo, &plist);
                    if (ret < 0) {
                            gnutls_assert();
                            return ret;
                    }
    
                    if (plist.key_ids_size == 0) {
                            gnutls_assert();
                            return GNUTLS_E_REQUESTED_DATA_NOT_AVAILABLE;
                    }
    
    So a slot with a single key will fail when trying to find a certificate
    
    Subsequent uses of "plist" in that function also show that it's expected
    to contain the real slot count:
    
                    for (i = 0; i < plist.key_ids_size; i++) {
    
    Signed-off-by: Benjamin Herrenschmidt <benh@kernel.crashing.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Wed Mar 23 16:55:51 2022 +0100

    Consolidate FIPS .hmac files
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Fri Mar 18 11:37:10 2022 +0100

    system config disable KTLS
    
    Added option for system config `ktls = false` to disable ktls
    system-wide
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Pedro Monreal <pmgdeb@gmail.com>
Date:   Tue Mar 22 13:01:53 2022 +0100

    lib/crypto-selftests.c: Add a selftest for PBKDF2 that complies with FIPS 140-3.
    
    Signed-off-by: Pedro Monreal <pmgdeb@gmail.com>

Author: Tobias Heider <tobias.heider@canonical.com>
Date:   Mon Mar 14 16:17:28 2022 +0100

    Use custom allocators for GMP to make sure temporary secrets
    from cryptographic operations in nettle are deleted safely.
    
    Signed-off-by: Tobias Heider <tobias.heider@canonical.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Mar 18 08:10:12 2022 +0100

    devel/release-steps.md: expand steps to generate tarball [ci-skip]
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Mar 18 07:54:06 2022 +0100

    NEWS: mention couple more changes in 3.7.4 release [ci-skip]
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Sam James <sam@gentoo.org>
Date:   Fri Mar 18 05:51:29 2022 +0000

    configure.ac: fix zstd detection
    
    Fixes typo in zstd detection.
    
    None of the used autoconf macros will define `has_zstd_h` so
    configure will (AFAICT) always fail to find zstd, even if it succeeded
    via pkg-config moments before.
    
    Drop it and rely solely on pkg-config as that's the only search
    we're actually doing.
    
    Fixes: https://gitlab.com/gnutls/gnutls/-/issues/1343
    Signed-off-by: Sam James <sam@gentoo.org>

Author: Sam James <sam@gentoo.org>
Date:   Fri Mar 18 05:40:28 2022 +0000

    configure.ac: fix brotli/zstd configure argument name
    
    The old `./configure` arguments for brotli and zstd respectively
    were inconsistent with the `./configure --help` output.
    
    Old: --without-libbrotli --without-libzstd (also --with-*)
    New: --without-brotli --without-zstd (also --with-*)
    
    Fixes: https://gitlab.com/gnutls/gnutls/-/issues/1342
    Signed-off-by: Sam James <sam@gentoo.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Mar 16 11:19:29 2022 +0100

    cligen: update git submodule
    
    To avoid emitting empty "list" substruct in header files, as well as
    assuming the Python pwd module is always available.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Wed Mar 16 15:42:40 2022 +0100

    Release 3.7.4
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Tue Mar 8 18:01:37 2022 +0100

    Make gnutls compliant to RFC5280
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 14 16:03:07 2022 +0100

    cli, serv: allow multiple --compress-cert options
    
    This eliminates the need of parsing the comma separated list manually.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Tobias Heider <tobias.heider@canonical.com>
Date:   Sun Mar 13 23:58:42 2022 +0100

    Handle all cases of calloc returning NULL.
    
    Signed-off-by: Tobias Heider <tobias.heider@canonical.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Fri Mar 11 18:22:18 2022 +0100

    Fix global-ini-handler
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 10 15:58:08 2022 +0100

    Make option specification type-safe
    
    This switches the CLI code and documentation generation to the
    external cligen module, which provides more type-safe specification.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Tobias Heider <tobias.heider@canonical.com>
Date:   Wed Mar 9 01:18:20 2022 +0100

    fips: use GNUTLS_FIPS140_STRICT instead of magic number.
    
    Signed-off-by: Tobias Heider <tobias.heider@canonical.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Mar 9 08:07:58 2022 +0100

    locks: define lock functions as a macro
    
    When threads are not supported, glthread_* functions are defined as
    no-op and thus dereferencing lock variables in inline functions will
    cause compilation error.  This change fixes it by redefining our lock
    functions as a macro so it will also be compiled out.
    
    Reported by Fabrice Fontaine in:
    https://gitlab.com/gnutls/gnutls/-/issues/1330
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Mar 9 07:25:01 2022 +0100

    .gitlab-ci.yml: prolong timeout for slow CI jobs
    
    Suggested by Marvin Scholz in:
    https://gitlab.com/gnutls/gnutls/-/merge_requests/1543#note_859825412
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Feb 23 19:48:52 2022 +0100

    tpm2: dynamically load tss2 libraries as needed
    
    libtss2-esys links to OpenSSL or mbed TLS for cryptography, which may
    cause packaging issues.  This instead dlopen's tss2 libraries as
    needed so non-TPM applications continue working without loading
    multiple crypto libraries.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Wed Jan 12 14:57:42 2022 +0100

    Add compress_certificate extension (RFC8879)
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Craig Gallek <cgallek@gmail.com>
Date:   Sun Feb 27 10:39:07 2022 -0500

    x509: fix return error code for failed decryption without key
    
    Decrypting an encrypted private key previously returned
    GNUTLS_E_DECRYPTION_FAILED when no password was supplied.  This changed when
    decryption via pin callbacks was added in d31b89de.
    
    That change should have included a check for callback existence in order to
    preserve the error path of the no-password case.
    
    This adds the check and a test for the previous behavior.
    Resolves bug #1321
    
    Signed-off-by: Craig Gallek <cgallek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 24 09:55:01 2022 +0100

    gnutls_record_send_file: make it work with non-blocking I/O
    
    When either read() or gnutls_record_send() returns EAGAIN, just return
    to the caller so it can call this function again, instead of retrying
    internally.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Marvin Scholz <epirat07@gmail.com>
Date:   Wed Feb 23 19:03:51 2022 +0100

    configure.ac: add missing Libs.private for macOS
    
    On macOS the CoreFoundation and Security frameworks are used by
    GnuTLS, however those were missing in the Libs.private in the .pc
    resulting in link failures with static builds when relying on the
    output of pkg-config --static.
    
    Signed-off-by: Marvin Scholz <epirat07@gmail.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Wed Feb 16 11:25:11 2022 +0100

    non-KTLS sendfile test
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Wed Feb 16 11:23:36 2022 +0100

    non-KTLS sendfile
    
    Added: sendfile API functionality for non KTLS enabled builds.
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Feb 22 17:09:46 2022 +0100

    algorithms: ensure _list() exclude non-existing algorithms
    
    This aligns the behavior of _list() function for sign/pk to the one
    for cipher/mac: the former previously returned all the algorithms
    defined, while the latter returns only algorithms compiled in.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Feb 22 17:25:26 2022 +0100

    Revert "algorithms: compile out GOST algorithm IDs if they are disabled"
    
    This reverts commit aa94bcbdaa55899f4f4ae13dc3e9a8c559354676.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Wed Feb 16 11:22:47 2022 +0100

    auto-generated files update
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Tue Nov 16 12:05:53 2021 +0100

    ktls: sendfile
    
    added API function: gnutls_record_send_file().
    added: _gnutls_ktls_send_file() function which increases the performance
    by offloading the file encryption to kernel, thus the data never goes
    to userspace.
    updated tests/gnutls_ktls to cover new API
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Feb 21 16:36:32 2022 +0100

    algorithms: compile out GOST algorithm IDs if they are disabled
    
    When compiled with --disable-gost, gnutls-cli --list still prints GOST
    algorithms for public key systems and signatures.  This change adds
    compile time checks to suppress them.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Feb 21 18:19:25 2022 +0100

    lib/algorithms: add UB warnings on late allowlisting API invocations
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Feb 14 13:48:37 2022 +0100

    lib/priority: defer setting system-wide priority string
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Feb 14 12:44:57 2022 +0100

    lib/priority: split up update_system_wide_priority_string
    
    This is done in preparation for deferring priority string evaluation.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Feb 21 16:28:49 2022 +0100

    priority: compile out GOST algorithms IDs if they are disabled
    
    When compiled with --disable-gost, gnutls-cli --priority NORMAL --list
    still prints GOST algorithms for ciphers, MACs, and signatures.  This
    change adds compile time checks to suppress them.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Fri Feb 18 11:05:15 2022 +0100

    bump GNUTLS_MAX_ALGORITHM_NUM / MAX_ALGOS
    
    Fedora 36 LEGACY crypto-policy uses allowlisting format
    and is long enough to blow past the 64 priority string
    elements mark, causing, effectively, priority string truncation.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Dimitris Apostolou <dimitris.apostolou@icloud.com>
Date:   Thu Feb 17 17:35:59 2022 +0200

    Fix typos
    
    Signed-off-by: Dimitris Apostolou <dimitris.apostolou@icloud.com>

Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Thu Feb 17 11:46:29 2022 +0100

    Disable some tests in fips mode
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 10 17:35:13 2022 +0100

    _gnutls_pkcs_raw_{decrypt,encrypt}_data: use public crypto API
    
    These functions previously used the internal crypto
    API (_gnutls_cipher_*) which does not have algorithm checks for FIPS.
    
    This change switches the code to use the public crypto
    API (gnutls_cipher_*) to trigger proper state transitions under FIPS
    mode.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 10 16:43:08 2022 +0100

    pkcs12: mark MAC generation and verification as FIPS non-approved
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Feb 15 17:38:20 2022 +0100

    gnutls_transport_is_ktls_enabled: fix return value of stub
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jan 12 10:37:53 2022 +0100

    gnutls_ciphersuite_get: new function to get unique ciphersuite name
    
    The existing method to obtain the name of the currently negotiated TLS
    ciphersuite is as follows:
    
    - call gnutls_cipher_get, gnutls_mac_get, gnutls_kx_get
    - call gnutls_cipher_suite_get_name with the value from the above functions
    
    This process is cumbersome and only works with TLS 1.2 or earlier;
    moreover the returned names are GnuTLS specific.
    
    This change adds a new function gnutls_ciphersuite_get to eliminate
    those limitations.  It returns the "canonical" name of the
    ciphersuite, which is mostly identical to the ones registered in IANA,
    with an exception for compatibility.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Dec 20 09:28:10 2021 +0100

    tls-fuzzer: prolong timeout for FFDHE tests
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Nov 26 20:03:15 2021 +0100

    .gitlab-ci.yml: prolong timeout for fedora-nettle-minigmp/test
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Nov 26 09:37:58 2021 +0100

    .gitlab-ci.yml: fix nettle installation path
    
    .fedora-nettle/build clones the nettle into "nettle-git" and
    temporarily change the working directory while buidling it.  After
    moving back to the original working directory, the installation path
    should be prefixed with "${PWD}/nettle-git/".
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Feb 1 15:19:52 2022 +0100

    certtool --generate-privkey: update warnings on RSA key sizes
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jan 27 18:17:43 2022 +0100

    rsa_generate_fips186_4_keypair: accept a few more modulus sizes
    
    While _rsa_generate_fips186_4_keypair was modified to accept modulus
    sizes other than 2048 and 3076, rsa_generate_fips186_4_keypair, which
    calls that function, was not updated to accept such modulus sizes.
    
    Spotted by Alexander Sosedkin.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 7 11:24:36 2022 +0100

    .gitlab-ci.yml: update Fedora images to Fedora 35
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Seppo Yli-Olli <seppo.yliolli@gmail.com>
Date:   Mon Jan 31 18:32:28 2022 +0200

    Bump libgnutlsxx soname due to ABI break
    
    db_check_entry and db_check_entry now have const parameters
    
    Signed-off-by: Seppo Yli-Olli <seppo.yliolli@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 28 07:49:42 2022 +0100

    configure.ac: make --with-tpm and --with-tpm2 independent
    
    These features are not mutually exclusive, so it doesn't make sense to
    disable the TPM 1.2 support with TPM 2.0 support.
    
    Reported by Jan Palus in:
    https://gitlab.com/gnutls/gnutls/-/issues/1313
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 28 12:50:56 2022 +0100

    gen-getopt.py: avoid struct member name clash with C keywords
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 28 07:55:25 2022 +0100

    tests: tcp_connect: avoid resource leak on error path
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 28 08:48:47 2022 +0100

    README.md: fix versions in build status and add 3.6.x
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Jan Palus <jpalus@fastmail.com>
Date:   Fri Jan 28 11:07:02 2022 +0100

    ktls: fix _gnutls_ktls_send_control_msg return value
    
    always returned 0 on success while contract mandates to return number of
    bytes sent
    
    Fixes #1314
    
    Signed-off-by: Jan Palus <jpalus@fastmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 28 06:35:45 2022 +0100

    release-steps: fix markup
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Thu Jan 27 13:54:21 2022 +0100

    KTLS: hotfix
    
    fixed: keys will be set only when both sockets were enabled for ktls
    fixed: session->internals.ktls_enabled left uninitialized for non
    ktls-enabled build
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Jan 26 16:25:01 2022 +0100

    lib/accelerated: use unlikely on buffer length checks more consistently
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Jan 26 16:15:36 2022 +0100

    lib/accelerated: rearranged several size checks to avoid overflow
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Jan 25 12:32:59 2022 +0100

    tests/scripts/common: fix skipping over x86-specific tests
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Jan 25 13:37:55 2022 +0100

    tests/slow/test-hash-large: output GNUTLS_CPUID_OVERRIDE hints
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Jan 25 13:46:46 2022 +0100

    tests/slow/cipher-api-test: add happy paths, specific error checks etc
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Tue Jan 25 13:36:19 2022 +0100

    lib/accelerated: report GNUTLS_E_SHORT_MEMORY_BUFFER in many places
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Jan 24 17:37:24 2022 +0100

    .gitlab-ci.yml: enable hardware acceleration in UB+ASAN jobs
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Jan 24 17:34:35 2022 +0100

    tests/slow/cipher-api-test: actually test for short buffer...
    
    ... avoiding the case when different failures mask the intended one
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Jan 24 17:33:48 2022 +0100

    lib/accelerated/x86/aes-gcm-x86-pclmul-avx: add short buffer checks
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Sun Jan 23 13:40:17 2022 +0100

    testsuite: Fix endless loop on /bin/sh without $RANDOM
    
    Closes #1315
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Sun Jan 23 07:52:21 2022 +0100

    testsuite: Fix missed instances of &> redirection
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Fri Jan 21 18:25:52 2022 +0100

    Avoid &> redirection bashism in testsuite
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jan 17 16:48:10 2022 +0100

    Release 3.7.3
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jan 18 06:43:07 2022 +0100

    tests: privkey-keygen: fix memory leak
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Oct 30 08:56:07 2021 +0200

    x509: fix thread-safety in gnutls_x509_trust_list_verify_crt2
    
    This function previously used gnutls_x509_trust_list_get_issuer
    without GNUTLS_TL_GET_COPY flag, which is required when the function
    is called from multi-threaded application and PKCS #11 trust store is
    in use.
    
    Reported and the change suggested by Remi Gacogne in:
    https://gitlab.com/gnutls/gnutls/-/issues/1277
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jan 16 07:57:02 2022 +0100

    cli: add --list-config option
    
    With this option gnutls-cli prints the build-time configuration of the
    library, retrieved through gnutls_get_library_config.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jan 11 07:36:27 2022 +0100

    fips: add build option to embed FIPS module info in library config
    
    This adds a couple of configure options, --with-fips140-module-name
    and --with-fips140-module-version, which packagers can use to embed
    FIPS module information in the library.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jan 11 07:34:59 2022 +0100

    global: add API to retrieve library configuration at run time
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jan 16 12:17:39 2022 +0100

    configure.ac: emit feature summary as C macro
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jan 16 16:19:53 2022 +0100

    tests: suppress GCC -fanalyzer warnings
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jan 16 16:00:10 2022 +0100

    .gitignore: ignore more files
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jan 16 15:59:01 2022 +0100

    src: avoid overriding noinst_PROGRAMS
    
    In src, we now have two helper programs: systemkey and dumpcfg.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jan 13 14:30:02 2022 +0100

    build: hide maintainer tool invocation behind AM_V_GEN
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Thu Jan 13 14:35:07 2022 +0100

    tests: use more aliases in tests for better alias testing coverage
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 7 10:02:32 2022 +0100

    .gitlab-ci.yml: run static analyzers on Python files
    
    This runs a couple of code analysis on the Python scripts added to
    remove AutoGen dependency.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 7 09:58:11 2022 +0100

    .gitlab-ci.yml: bump cache key for python3 detection
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jan 5 08:09:36 2022 +0100

    README.md: mention Python as requirement instead of AutoGen
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jan 5 07:39:10 2022 +0100

    src: remove AutoGen .def files
    
    As neither the tools nor documentation depends on AutoGen, we don't
    need to include the AutoGen definition files.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jan 5 07:24:03 2022 +0100

    doc: generate man-pages from JSON
    
    This replaces man-pages generation previously provided by the autogen
    -Tagman.tpl command with a Python script (gen-cmd-man.py).
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jan 4 09:06:21 2022 +0100

    doc: generate texinfo files from JSON
    
    This replaces texinfo generation previously provided by the autogen
    -Tagtexi.tpl command with a Python script (gen-cmd-texi.py).
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jan 3 11:02:43 2022 +0100

    src: remove included copy of libopts
    
    As no tools link with libopts anymore, we don't need to include it in
    the distribution.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jan 3 10:30:34 2022 +0100

    src: replace autoopts/libopts with minimal config parser
    
    This replaces configuration file parsing code previously provided by
    <autoopts/options.h>, with a minimal compatible implementation.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Dec 31 18:13:58 2021 +0100

    src: generate option handling code from JSON
    
    This replaces AutoGen based command-line parser with a Python
    script (gen-getopt.py), which takes JSON description as the input.
    The included JSON files were converted one-off using the parse-autogen
    program: https://gitlab.com/dueno/parse-autogen.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jan 4 15:18:26 2022 +0100

    python: add library for handling JSON-based option description
    
    This adds the jsonopts Python module used by the command-line parser
    generator and documentation generators in the following commits.  This
    also bumps the required Python interpreter version to 3.6.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>
    Co-authored-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jan 13 09:36:52 2022 +0100

    pkcs12: use the correct MAC algorithm for GOST key generation
    
    According to the latest TC-26 requirements, the MAC algorithm used for
    PBKDF2 should always be HMAC_GOSTR3411_2012_512.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jan 12 08:15:24 2022 +0100

    tests: simple: check if the digest algorithm is compiled in
    
    When the library is built with --disable-gost, gnutls_digest_get_id
    returns GNUTLS_DIG_UNKNOWN for GOST algorithms.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jan 11 14:07:56 2022 +0100

    x509: fix potential wrong usage of memcpy
    
    Spotted by GCC analyzer:
    
      common.c:552:17: warning: use of NULL 'out.data' where non-null expected [CWE-476] [-Wanalyzer-null-argument]
        552 |                 memcpy(output_data, out.data, (size_t) out.size);
            |                 ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jan 9 08:34:52 2022 +0100

    cert-auth: suppress false-positive warnings with GCC analyzer
    
    When compiled with gcc -fanalyzer, it reports:
    
      cert.c: In function '_gnutls_pcert_to_auth_info':
      cert.c:85:17: error: dereference of NULL 'info' [CWE-476] [-Werror=analyzer-null-dereference]
         85 |         if (info->raw_certificate_list != NULL) {
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 7 17:48:22 2022 +0100

    gnutls_pkcs12_generate_mac: use SHA256 by default
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Dec 20 16:16:23 2021 +0100

    .gitlab-ci.yml: reduce PKCS#12 iteration count while testing
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Dec 21 15:02:45 2021 +0100

    tests: check algorithms for generating PKCS#12 file
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Dec 26 17:40:42 2021 +0100

    cipher-api-test: mention why it is written using fork
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Nov 23 15:23:34 2021 +0100

    fips: plumb service indicator to symmetric key crypto operations
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>
    Co-authored-by: Pedro Monreal <pmonrealgonzalez@suse.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Aug 31 13:29:45 2021 +0200

    fips: plumb service indicator to public key crypto operations
    
    This installs service indicator state transitions in certain public
    key operations in gnutls_crypto_pk_st, namely:
    
    * fallible operations
      - encrypt
      - sign
      - generate_keys
      - derive
    
    * infallible operations
      - decrypt, decrypt2
      - verify
    
    other operations, such as generate_params, are not considered as
    crypto operation.  Note that fallible operations above mean that those
    return value could indicate error, while infallible operations do not
    have distinction between errors and failures: decrypt/verify failures
    are treated as a successful completion of the operation.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>
    Co-authored-by: Pedro Monreal <pmonrealgonzalez@suse.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Dec 21 15:17:55 2021 +0100

    _gnutls_pkcs_generate_key: use HMAC-SHA256 for PBKDF2
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Dec 20 16:34:30 2021 +0100

    pkcs12: determine iteration count for MAC at build time
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Dec 20 16:13:06 2021 +0100

    pkcs7: determine iteration count for PBKDF2 at build time
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Dec 20 15:56:24 2021 +0100

    certtool: --to-p12: use modern algorithms by default
    
    Currently certtool uses PKCS12-3DES-SHA1 for encrypting keys in
    PKCS#12, while it is suggested to migrate to more modern algorithms,
    namely AES-128-CBC with PBKDF2 and SHA-256:
    https://bugzilla.redhat.com/show_bug.cgi?id=1759982
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jul 23 10:31:08 2021 +0200

    fips: add functions to inspect thread-local FIPS operation state
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Thu Jan 6 07:17:01 2022 +0100

    Drop unquoted angle brackets in gtk-doc comment.
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Thu Jan 6 07:15:31 2022 +0100

    Fix gtk-doc build, use http URI in sgml master.
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Alon Bar-Lev <alon.barlev@gmail.com>
Date:   Sat Jan 1 21:12:51 2022 +0200

    p11tool: add --mark-always-authenticate option
    
    Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

Author: Alon Bar-Lev <alon.barlev@gmail.com>
Date:   Sun Jan 2 19:31:33 2022 +0200

    doc: updated copyrights for 2022
    
    Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Nov 18 19:02:03 2021 +0100

    accelerated: fix CPU feature detection for Intel CPUs
    
    This fixes read_cpuid_vals to correctly read the CPUID quadruple, as
    well as to set the bit the ustream CRYPTOGAMS uses to identify Intel
    CPUs.
    
    Suggested by Rafael Gieschke in:
    https://gitlab.com/gnutls/gnutls/-/issues/1282
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Dec 22 17:00:03 2021 +0100

    padlock: reset _gnutls_x86_cpuid_s only after padlock check succeeds
    
    Otherwise it clears _gnutls_x86_cpuid_s which may already hold valid
    CPUID detected for Intel and AMD CPUs.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Dec 22 09:12:25 2021 +0100

    wrap_nettle_hash_fast: avoid calling _update with zero-length input
    
    As Nettle's hash update functions internally call memcpy, providing
    zero-length input may cause undefined behavior.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Dec 22 08:22:04 2021 +0100

    gnutls_{hash,hmac}_copy: mention the functions do not always work
    
    It is known that some built-in accelerated implementation, such as
    AF_ALG, does not support copying hash/hmac contexts.  This expands the
    documentation to suggest checking the return value of those functions.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Dec 20 17:47:36 2021 +0100

    tests: extend system-override-curves-allowlist with key generation
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Dec 20 16:50:59 2021 +0100

    tests: tweak system-override-curves-allowlist insignificantly
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Fri Dec 17 18:49:27 2021 +0100

    README: document tpm2-tss-engine test dependency
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Thu Dec 16 12:46:38 2021 +0100

    use sha384_digest in lib/accelerated/aarch64/sha-aarch64.c sha384
    
    Mirrors https://gitlab.com/gnutls/gnutls/-/merge_requests/1466
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Thu Dec 2 16:35:31 2021 +0100

    ktls: flags
    
    ktls enum flags API
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Fri Oct 15 15:00:17 2021 +0200

    KTLS: API
    
    ktls is enabled by default, we can check if inicialization was
    succesfull with gnutls_transport_is_ktls_enabled
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Dec 9 11:22:14 2021 +0100

    .gitignore: ignore tests/x509cert-ct
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Dec 9 11:03:50 2021 +0100

    X509 CT: defer filling in the length field
    
    This eliminates the need of precalculating the payload size, to make
    it easier to adapt to new format.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Fri Dec 10 13:47:21 2021 +0100

    tests: fix out of tree builds with ASAN
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Thu Nov 11 14:05:40 2021 +0100

    tests: add protocol-set-allowlist
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Thu Nov 11 14:04:54 2021 +0100

    tests: add tcp_connect to utils
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Dec 9 10:48:58 2021 +0100

    X509 CT: use size_t for array index instead of unsigned
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Ander Juaristi <a@juaristi.eus>
Date:   Fri Nov 26 18:20:44 2021 +0100

    Update symbols
    
    Signed-off-by: Ander Juaristi <a@juaristi.eus>

Author: Ander Juaristi <a@juaristi.eus>
Date:   Wed Nov 17 19:28:50 2021 +0100

    devel: Suppress new API functions
    
    Signed-off-by: Ander Juaristi <a@juaristi.eus>

Author: Ander Juaristi <a@juaristi.eus>
Date:   Sat Nov 28 19:04:35 2020 +0100

    x509 CT: Add tests
    
    Signed-off-by: Ander Juaristi <a@juaristi.eus>

Author: Ander Juaristi <a@juaristi.eus>
Date:   Mon Nov 15 20:03:12 2021 +0100

    x509 CT: implement new public API
    
    This commit implements import and export functions for the X.509
    Certificate Transparency Signed Certificate Timestamp (SCT) extension
    (RFC 6962).
    
    A new constant GNUTLS_X509EXT_OID_CT_SCT is introduced
    with the value "1.3.6.1.4.1.11129.2.4.2".
    
    The following new public API functions are introduced:
    
        - gnutls_x509_ext_ct_scts_init
        - gnutls_x509_ext_ct_scts_deinit
        - gnutls_x509_ext_ct_import_scts
        - gnutls_x509_ext_ct_export_scts
        - gnutls_x509_ct_sct_get_version
        - gnutls_x509_ct_sct_get
    
    Signed-off-by: Ander Juaristi <a@juaristi.eus>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Nov 30 14:33:33 2021 +0100

    devel/libgnutls.abignore: ignore drbg_aes_* functions
    
    These functions are only defined when compiled with
    --enable-fips140-mode.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu May 6 12:41:40 2021 +0200

    priority: support allowlisting in configuration file
    
    This adds a new mode of interpreting the [overrides] section.  If
    "override-mode" is set to "allowlisting" in the [global] section, all
    the algorithms (hashes, signature algorithms, curves, and versions)
    are initially marked as insecure/disabled.  Then the user can enable
    them by specifying allowlisting keywords such as "secure-hash" in the
    [overrides] section.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>
    Co-authored-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Nov 27 16:48:51 2021 +0100

    CONTRIBUTING.md: clarify how to introduce new API
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Nov 27 16:39:41 2021 +0100

    release-steps: "make abi-dump-latest" at release time
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Nov 27 16:36:17 2021 +0100

    build: stop running abi-dump-latest at "make files-update"
    
    The procedure of registering ABI updates has changed in
    bd3c78b9d10937adb1855b85bca1864972a1c986.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Nov 24 18:44:13 2021 +0100

    build: update to use the latest valgrind-tests module from Gnulib
    
    This adjust the existing valgrind invocations in the test suite with:
    https://www.gnu.org/software/gnulib/manual/html_node/Valgrind-options.html
    
    - make --suppressions option to per directory, using AM_VALGRINDFLAGS
    - use LOG_VALGRIND for LOG_COMPILER
    - quote '$(LOG_VALGRIND)' in TESTS_ENVIRONMENT
    - move gl_VALGRIND_TESTS_DEFAULT_NO call before gl_INIT
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Evgeny Grin <k2k@narod.ru>
Date:   Fri Nov 26 14:08:22 2021 +0300

    sockets: fixed compiler warning on Windows x32
    
    Signed-off-by: Evgeny Grin <k2k@narod.ru>

Author: Evgeny Grin <k2k@narod.ru>
Date:   Fri Nov 26 13:50:52 2021 +0300

    sockets: fixed building for Windows with compilers without VLA support
    
    Signed-off-by: Evgeny Grin <k2k@narod.ru>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed May 5 16:27:55 2021 +0200

    priority: refactor config file parsing
    
    This adds the following refactoring:
    
    - avoid side-effects during parsing the config file, by separating
      application phase; the parsed configuration can be applied globally
      with cfg_apply, after validation
    - make _gnutls_*_mark_{disabled,insecure} take an ID instead of the
      name
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Nov 16 18:46:41 2021 +0100

    locks: deprecate gnutls_global_set_mutex
    
    As the library now uses static mutexes, rwlocks, and onces, it doesn't
    make much sense to only replace dynamic mutex usage.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Nov 14 14:57:15 2021 +0100

    locks: use once execution for on-demand initialization of globals
    
    This makes sure that the global variables are initialized only once.
    Most of those variables are initialized at ELF constructor, though a
    couple of occasions they are initialized on-demand: the global keylog
    file pointer and TPM2 TCTI context.  To properly protect the
    initialization this patch uses gl_once provided by Gnulib.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Nov 14 16:39:29 2021 +0100

    locks: rework rwlock primitives
    
    Remove GNUTLS_STATIC_RWLOCK_*LOCK macros and respect return values of
    rwlock primitives.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Nov 16 18:20:24 2021 +0100

    pkcs11: switch to using static mutex
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Nov 16 18:00:12 2021 +0100

    verify-tofu: switch to using static mutex for locking
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Nov 14 14:04:59 2021 +0100

    locks: replace custom mutex wrappers with "glthread/lock.h"
    
    As Gnulib provides portability wrappers of mutex implementations, we
    don't need to provide similar wrappers by ourselves.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Fri Mar 22 14:52:10 2019 +0100

    Port openconnect TPM2 code
    
    This introduces transparent loading of TPM2 keys which are in PEM
    form by gnutls_privkey_import_x509_raw() and higher level functions
    which wrap it.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>
    Co-authored-by: David Woodhouse <dwmw2@infradead.org>
    Co-authored-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Nov 8 19:07:28 2021 +0100

    tests: set $abs_top_builddir in more places
    
    `$abs_top_builddir` has been used all across tests' subdirectories
    (through tests/scripts/common.sh)
    but has only been defined for tests/suite/ ones.
    Defining it in other Makefiles where `top_builddir` is being passed.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Oct 30 17:17:47 2021 +0200

    priority: rework config reloading logic and locking
    
    The previous reloading logic relied on the existence of [priority]
    section (in the initial loading) as an indicator whether the file is
    loaded.  This didn't work well in the following cases:
    - when the section didn't exist initially and then is added later
    - when the section existed initially and then is removed later
    To handle these cases, this change adds a new flag
    system_priority_file_loaded which can be used together with the mtime
    check.
    
    This also adds an rwlock to protect global configuration.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Nov 1 16:46:50 2021 +0100

    Revert "priority: fix potential race in reloading system-wide config"
    
    This reverts commit 890c6937a3cfb4a0704bc815324221ec4cb89840.
    Considering the entire logic around reloading the config file, the fix
    was suboptimal.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Oct 28 18:55:26 2021 +0200

    priority: fix potential race in reloading system-wide config
    
    _gnutls_update_system_priorities is called from gnutls_priority_set*
    functions every time when the SYSTEM keyword is used and updates a
    global variable system_wide_priority_strings if the configuration
    changes.  Although the critical path is protected with mtime check, it
    should also hold a lock to avoid occasional race condition in
    multi-thread programs.  This also clears
    system_wide_priority_strings_init upon unloading and before reloading
    the config file (thanks to Alexander Sosedkin).
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Thu Oct 21 12:46:56 2021 +0200

    .gitlab-ci.yml: add caching to cppcheck
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Oct 26 07:50:16 2021 +0200

    devel: update release procedure taking into account of abi-dump
    
    As the *.abi files have been moved into a separate repository, we need
    an extra step to update the repository for new release.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Oct 20 17:49:56 2021 +0200

    NEWS: add a notice of insecure-hash filtering ciphersuites on PRF
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Oct 20 14:37:07 2021 +0200

    tests: add system-override-hash-influences-prf
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Oct 20 14:36:44 2021 +0200

    priority: filter out ciphersuites with prf blocked by insecure-hash
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Wed Oct 20 14:34:58 2021 +0200

    priority: refactor ciphersuite filtering
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Fri May 14 15:56:06 2021 +0200

    ktls: basic implementation of SW mode
    
    ktls enables us to offload encryption/decryption to the kernel
    
    prerequisites:
            - configured with `--enable-ktls`
            - tls module `modprobe tls` check with 'lsmod | grep tls'
            - per connection:
                    gnutls_transport_set_int{2} must be set
    
    When prerequisities are met then ktls is used by default.
    
    If GnuTLS encounters a error during KTLS initialization, it will
    not use ktls and fallback to userspace.
    
    Signed-off-by: Frantisek Krenzelok <krenzelok.frantisek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 18 16:27:46 2021 +0200

    devel: make use of abidw --drop-private-types
    
    This will produce more compact abixml output.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 18 11:49:46 2021 +0200

    devel: move .abi files into a separate repository
    
    Changes to the .abi files are a bit too noisy to track in the main
    repository.  This moves the files out of this repository and embed it
    as a git submodule.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Thu Sep 23 09:03:50 2021 +0200

    fix mingw64 detection
    
    __MINGW64__ is only defined for 64 bits builds of mingw64 [1].
    The intended test what to only use the CertEnumCRLsInStoreFunc via LoadLibrary
    for some ancient mingw32 build and never for mingw64.
    
    __MINGW64_VERSION_MAJOR is a proper define to identify mingw64 against mingw32.
    
    [1] https://sourceforge.net/p/predef/wiki/Compilers/
    
    Co-authored-by: Johannes Kauffmann <johanneskauffmann@hotmail.com>
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Sep 17 11:03:25 2021 +0200

    wrap_nettle_hash_exists: add missing hash algorithms
    
    This adds SHAKE-128, SHAKE-256, and RIPEMD-160 to the supported
    algorithms by nettle.  While SHAKEs are not a hash algorithm but an
    XOF, it would be consistent to report they are implemented.
    
    The simple test is expanded to exercise the code
    path (gnutls_digest_get_id → wrap_nettle_hash_exists).
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Sep 18 07:18:59 2021 +0200

    fuzz: explicitly supply LDFLAGS to clang++ command line
    
    This prevented fuzzer programs being linked in Ubuntu 20.03, used in
    oss-fuzz.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri Sep 17 16:37:24 2021 -0400

    lib/x509: Avoid memcpy when string is empty
    
    This fixes an ASAN warning in fuzz/gnutls_private_key_parser_fuzzer
    when run against the malformed private key
    fuzz/gnutls_private_key_parser_fuzzer.in/10a5c92fa30ddb6cbb4286d7699b2b7a7e032b17
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Wed Aug 11 17:31:40 2021 -0400

    NEWS: added news about certtool handling x448 and x25519
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Wed Aug 11 15:59:21 2021 -0400

    tests: add test for generating x25519 and x448 certificates
    
    These certs should work just fine for the purposes of cryptographic
    e-mail (S/MIME).
    
    These usage flags are also used in the end-entity certificates found
    in https://datatracker.ietf.org/doc/draft-ietf-lamps-samples/
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 14 17:14:41 2021 -0400

    tests: update details about sample X25519 certificate
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 20:14:53 2021 -0400

    certtool: add x448 and x25519 for --key-type
    
    This is a simple extension of the certtool command-line interface.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 22:25:41 2021 -0400

    certtool: when making X25519 or X448 certs, always use "key agreement"
    
    This is related to #1227 -- but in this case, it's enforcing a
    requirement of RFC 8410 §5.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 21:53:47 2021 -0400

    x509: handle X25519 and X448 in read_pubkey
    
    _gnutls_x509_read_ecdh_pubkey is basically a clone of
    _gnutls_x509_read_eddsa_pubkey.  Another form of implementation
    would be to collapse these two static functions into a common
    function for all "CFRG" curves.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 21:30:53 2021 -0400

    nettle: handle X25519 and X448 in pk_fixup
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 20:23:41 2021 -0400

    x509: enable importing secret keys for X448 and X25519.
    
    _decode_pkcs8_modern_ecdh_key is virtually the same as
    _decode_pkcs8_eddsa_key.  Another implementation would be
    to collapse these two functions into one, since their structure
    is identical.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 19:53:28 2021 -0400

    Enable X25519 and X448 everywhere that EdDSA is supported.
    
    These are just trivial extension points where the codepath is the same
    for the ECDH scheme as it is for the EdDSA scheme.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 20:14:07 2021 -0400

    x509: handle X448 and X25519 in write_pubkey
    
    This uses the same structure as _gnutls_x509_write_eddsa_pubkey.
    
    Another way to write this would be to combine those two functions,
    despite X448 and X25519 not being EdDSA at all.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 20:12:15 2021 -0400

    pubkey: handle X25519 and X448 in gnutls_pubkey_import_pkcs11
    
    I am not confident in the strings I chose to match on in
    ASN1_ETYPE_PRINTABLE_STRING, in that I do not know what registry
    I should look this up in.
    
    The *parse_ecc_ecdh_params and *import_ecc_ecdh functions are tweaked
    analogs to the eddsa versions of those functions.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 19:48:10 2021 -0400

    nettle: extend pk_verify_priv_params to handle X25519 and X448
    
    This is basically a copy of the EdDSA case in the switch statement.
    
    Another way to implement it would be to augment the EdDSA case (and
    the functions it uses) to have that case also handle ECDH use of the
    CFRG curves.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 19:36:14 2021 -0400

    lib/pk: treat modern ECDH octet streams the same way as eddsa streams.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 7 19:34:59 2021 -0400

    lib/algorithms: add modern ecdh functions comparable to curve_is_eddsa
    
    This is useful for the so-called CFRG curves used in ECDH, x25519 and x448.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Thu May 6 14:10:46 2021 -0400

    algorithms: Explicitly name ECDH_X448_OID and ECDH_X25519_OID
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Sep 10 17:08:52 2021 +0200

    .gitlab-ci.yml: new ASan job with -DAGGRESSIVE_REALLOC
    
    This would exercise the same logic currently covered with
    fedora-valgrind-aggressive in each MR.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Sep 9 18:36:46 2021 +0200

    fuzz: allow multiple definitions of gnutls_rnd in oss-fuzz
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Sep 9 09:46:04 2021 +0200

    build: remove tautological if conditions
    
    Spotted by LGTM.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Sep 9 09:38:21 2021 +0200

    ext/{client,server}_cert_type: use proper types for integers
    
    Spotted by LGTM.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Sep 6 15:51:41 2021 +0200

    tests: use PYTHONPATH instead of creating symlinks in srcdir
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Sep 7 17:56:02 2021 +0200

    tls-fuzzer: update submodules to the latest
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Miroslav Lichvar <mlichvar@redhat.com>
Date:   Wed Sep 1 15:48:27 2021 +0200

    fix SSSE3 SHA384 to work more than once
    
    The output function called sha512_digest() instead of sha384_digest(),
    which caused the hash context to be reinitialized for SHA512 instead of
    SHA384 and all following digests using the hash handle were wrong.
    
    Signed-off-by: Miroslav Lichvar <mlichvar@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Sep 4 10:38:23 2021 +0200

    testcompat-openssl-tls13-cli.sh: disable early data testing
    
    This test is causing intermittent failure quite often in the CI.
    Let's temporarily disable it until the cause is properly investigated.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 5 18:48:09 2021 +0200

    testcompat-openssl-tls13-cli.sh: use different tmpdirs for sub-tests
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 5 17:28:43 2021 +0200

    tests: rework port locking
    
    This makes the locking logic per port, not per entire make process.
    It also makes use of absolute paths for locking directory, so that
    tlsfuzzer tests can use it.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Aug 30 19:26:49 2021 +0200

    tests/tls13/post-handshake-with-cert: avoid a race condition
    
    A server tries to close connection and kill the client after reauth.
    Client, in turn, attempts to send data in some cases.
    This patch makes the server wait for the client to terminate first.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Aug 30 19:38:03 2021 +0200

    tests: remove unused `terminate` from 2 tests
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Fri Aug 27 17:10:37 2021 +0200

    tests: add a safeguard to terminate()
    
    Add a safeguard to `terminate()` so that we don't kill whole pgroups.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Fri Aug 27 17:02:51 2021 +0200

    tests: don't kill whole pgroups
    
    `terminate()` executed from the child process results in a `kill(0, SIGTERM)`,
    bringing the whole pgroup down. `exit(1)` should be called instead.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Nick Child <nick.child@ibm.com>
Date:   Wed Aug 25 15:13:07 2021 -0400

    INSTALL.md: Update documentation on building static library [skip ci]
    
    As of commit a88eb79d88c53531c49d7cedfce2207f36ac8a9d, building a
    static archive (libgnutls.a) is off by default. This commit updates the
    documentation for building a static library in INSTALL.md .
    
    Signed-off-by: Nick Child <nick.child@ibm.com>

Author: Simon South <simon@simonsouth.net>
Date:   Sun Aug 22 08:41:36 2021 +0200

    guile: Add 'GNUTLS_DIG_SHA256' enum value.
    
    * guile/modules/gnutls/build/enums.scm (%digest-enum): Add 'sha256'.
    * guile/modules/gnutls.in: Export 'digest/sha256'.
    * guile/tests/x509-certificates.scm: Test 'digest/sha256' with
    'x509-certificate-fingerprint'.
    (%sha256-fingerprint): New constant.
    
    Signed-off-by: Simon South <simon@simonsouth.net>

Author: Simon South <simon@simonsouth.net>
Date:   Sun Aug 22 08:40:14 2021 +0200

    guile: Add binding for 'gnutls_x509_crt_get_fingerprint'.
    
    * guile/src/core.c (MAX_HASH_SIZE): New constant.
    (scm_gnutls_x509_certificate_fingerprint): New function.
    * guile/modules/gnutls.in: Export 'x509-certificate-fingerprint'.
    * guile/tests/x509-certificates.scm: Test 'x509-certificate-fingerprint'.
    (%sha1-fingerprint): New constant.
    (u8vector->hex-string): New procedure.
    
    Signed-off-by: Simon South <simon@simonsouth.net>

Author: Craig Gallek <cgallek@gmail.com>
Date:   Wed Aug 11 12:54:37 2021 -0400

    x509: pin/password callback support for openssl encrypted private keys
    
    This attempts to use the registered pin callback when the password for
    an encrypted openssl private key is not supplied.  This matches the
    functionality for PKCS8 sealed keys above and is similar to what openssl
    does in this situation.
    
    Signed-off-by: Craig Gallek <cgallek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Aug 7 09:16:50 2021 +0200

    mem: instrument with ASan memory poisoning as well as valgrind
    
    This makes it possible to catch undefined memory access in the more
    lightweight CI runs.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Aug 2 18:32:28 2021 +0200

    pk: add flags to force RSA-PSS salt length to match digest length
    
    This adds a couple of flags to RSA-PSS signing and verification, to
    enforce that the salt length matches the digest length.  That is not
    only recommended in RFC 4055, but also mandated in RFC 8446 in the TLS
    1.3 context.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jul 21 10:34:23 2021 +0200

    fips: allow more RSA modulus sizes
    
    Previously, we restricted RSA modulus size to be either 2048 or 3072
    bits in FIPS mode, following FIPS 186-4.  On the other hand, FIPS
    140-2 IG A.14 and FIPS 140-3 IG C.F updates it to allow arbitrary
    modulus sizes equal to or larger than 2048 bits under certain
    conditions.
    
    This change reflects the guidance, though it only allows known sizes
    due to the complexity of calculating the approximate security strength
    using the formula in FIPS 140-2 IG 7.5.
    
    Suggested-by: Stephan Mueller
    Reviewed-by: Stephan Mueller
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Aug 3 14:17:41 2021 +0200

    tests: tls13/key_share: rewrite as single process
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Aug 4 06:45:30 2021 +0200

    .gitlab-ci.yml: cppcheck: disable style checks
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Aug 3 11:44:52 2021 +0200

    devel: suppress cppcheck 2.5 false-positives
    
    This fixes errors and warnings as well as some style issues spotted by
    cppcheck 2.5.  Others are recorded in the suppressions file.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Tue Jul 13 23:53:12 2021 +0200

    gnutls_ocsp_resp_verify: Check key purpose if signer not on trust list
    
    According to [1] the id-kp-OCSPSigning key purpose is only needed for
    delegated signers, not signers explicitly set as trusted. The previous
    code would reject a signature directly from a CA on the trust list
    (without delegation) because the CA certificate didn't contain the
    id-kp-OCSPSigning key purpose.
    
    The tests included in this commit check:
    
    1. Is a signature directly from a CA on the trust list accepted?
    
    2. Is a signature from a delegated signer issued by a CA on the trust
       list accepted?
    
    3. Is a signature from a certificate without id-kp-OCSPSigning issued
       by a CA on the trust list rejected?
    
    Note that the CA in these tests is also the one that issued the
    certificate the OCSP response is for, but the code (current and
    previous) doesn't enforce this.
    
    [1] https://datatracker.ietf.org/doc/html/rfc6960#section-4.2.2.2
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jun 28 07:04:55 2021 +0200

    tests: set SH_LOG_COMPILER so sh tests run under $(SHELL)
    
    This omits the need of setting executable bits on shell script tests.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 25 08:39:12 2021 +0200

    key_share: treat X25519 and X448 as same PK type when advertising
    
    Previously, if both X25519 and X448 groups were enabled in the
    priority string, the client sent both algorithms in a key_share
    extension, while it was only capable of handling one algorithm from
    the same (Edwards curve) category.  This adds an extra check so the
    client should send either X25519 or X448.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Michael Catanzaro <mcatanzaro@redhat.com>
Date:   Tue Jun 22 14:12:09 2021 -0500

    Fix gnutls_certificate_set_trust_list() return value documentation
    
    This function is documented to return an error code, but in fact it has
    no return value and never fails. Fix this.
    
    Signed-off-by: Michael Catanzaro <mcatanzaro@redhat.com>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Sat Apr 24 22:02:14 2021 +0200

    guile: Writes to record ports handle EAGAIN/EINTR transparently.
    
    Reported at <https://issues.guix.gnu.org/47867>
    by Florian Pelz <pelzflorian@pelzflorian.de>.
    
    This is a followup to a229bb36c9592b151f6feb277238c41ab39f40a9.
    
    * guile/src/core.c (write_to_session_record_port) [USING_GUILE_BEFORE_2_2]:
    Keep looping upon GNUTLS_E_AGAIN and GNUTLS_E_INTERRUPTED.
    (write_to_session_record_port) [!USING_GUILE_BEFORE_2_2]: Loop on
    GNUTLS_E_INTERRUPTED and return -1 on GNUTLS_E_AGAIN if C_SESSION is
    backed by a file descriptor.
    * NEWS: Update.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 11 06:58:43 2021 +0200

    priority: reflect system wide config when constructing sigalgs
    
    Otherwise the client would advertise signature algorithms which it
    cannot use and cause handshake to fail.
    
    Reported by Philip Schaten in:
    https://lists.gnupg.org/pipermail/gnutls-help/2021-June/004711.html
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Jun 9 14:29:11 2021 +0200

    p11tool: mention how CKA_IDs of certs are calculated upon --write
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat May 29 07:18:17 2021 +0200

    Release 3.7.2
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat May 29 07:09:07 2021 +0200

    release-steps: remove unnecessary steps
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat May 29 06:56:57 2021 +0200

    AUTHORS: take into account of Co-authored-by:
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat May 29 06:52:42 2021 +0200

    .mailmap: update
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Tue May 18 16:32:55 2021 -0400

    certtool: order DN components by scale.
    
    DN components are expected to be ordered by scale, with the wire format
    representing larger-scale components (like country or organization) before
    smaller-scale components (like state or organizationalUnit).
    
    The bulk of the changes here of course are changes to the target
    certificates in the test suite.
    
    Note that a change was necessary in tests/cert-tests/crq.sh because it
    tests the "interactive" mode of certtool.  If any user is scripting
    certtool in this way, this change will cause a backwards-incompatible
    break.  However, I think this is OK -- the supported scripted/batch
    mode for certtool should use a template file, and I don't think it's
    important to maintain a strict api on the interactive mode.
    
    The main change here is to order the DN from least-specific-to-most,
    in particular:
    
        country, state, locality, org, orgunit, cn, uid
    
    But I've also made an additional arbitrary choice, which is that DC
    (domain component) comes *after* uid.  This was already the case in
    certificate generation, but in *request* generation, it was the other
    way around.  I've changed request generation to match this ordering
    from certificate generation.
    
    Closes: #1243
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu May 27 10:00:22 2021 +0200

    build: fix interface version dependencies in libgnutls.map
    
    Previously, the predecessor of GNUTLS_3_7_0 was mistakenly set to
    GNUTLS_3_4 instead of GNUTLS_3_6_14.  This fix shouldn't have any
    impact on ABI, given the dynamic loader doesn't take into account of
    ordering of versions.  See also the first paragraph on:
    https://www.akkadia.org/drepper/dsohowto.pdf#page=38
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu May 27 09:34:50 2021 +0200

    build: require libkcapi 1.3.0 or later if --enable-afalg
    
    The libkcapi 1.3.0 brings a couple of changes needed for GnuTLS:
    
     * fix: remove prctl PR_SET_DUMPABLE to allow library to be debugged
     * fix: ensure that sendmsg is always used as fallback when vmsplice cannot be used
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri May 28 17:05:56 2021 +0200

    tlsfuzzer: update git submodules
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri May 28 08:51:27 2021 +0200

    nettle: update git submodule to 3.7.2 release
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri May 28 08:50:19 2021 +0200

    gnulib: update git submodule
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu May 27 08:10:30 2021 +0200

    devel: update libtasn1 submodule
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Leonardo Bras <leobras.c@gmail.com>
Date:   Fri May 21 03:40:03 2021 -0300

    guile: Fix implicit conversion warning
    
    When building, the following warning may be printing:
    
      CC       guile_gnutls_v_2_la-utils.lo
    core.c: In function 'scm_gnutls_set_server_session_certificate_request_x':
    core.c:545:13: warning: implicit conversion from 'gnutls_certificate_request_t' to 'gnutls_certificate_status_t' [-Wenum-conversion]
      545 |   c_request = scm_to_gnutls_certificate_request (request, 2, FUNC_NAME);
          |             ^
    core.c:547:53: warning: implicit conversion from 'gnutls_certificate_status_t' to 'gnutls_certificate_request_t' [-Wenum-conversion]
      547 |   gnutls_certificate_server_set_request (c_session, c_request);
          |
    
    Fix this warning by changing c_request type to gnutls_certificate_request_t.
    
    Signed-off-by: Leonardo Bras <leobras.c@gmail.com>

Author: Leonardo Bras <leobras.c@gmail.com>
Date:   Fri May 21 03:11:29 2021 -0300

    ASN1 : Remove warnings related to old libtasn1 namings
    
    While compiling gnutls, some warnings related to deprecated names can be
    printed, such as:
    
    ./../x509/x509_int.h:392:13: warning: 'ASN1_TYPE' macro is deprecated, use 'asn1_node' instead.
      392 | int _gnutls_x509_write_key_int_le(ASN1_TYPE node, const char *value,
          |             ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    To avoid that, rename types as show in devel/libtasn1/NEWS (release 3.1):
    
    ASN1_DATA_NODE -> asn1_data_node_st
    ASN1_ARRAY_TYPE -> asn1_static_node (was asn1_static_node_t)
    ASN1_TYPE -> asn1_node
    ASN1_TYPE_EMPTY -> NULL
    static_struct_asn -> asn1_static_node_st
    node_asn_struct -> asn1_node_st
    node_asn -> asn1_node_st
    
    Signed-off-by: Leonardo Bras <leobras.c@gmail.com>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Mon May 17 13:33:28 2021 -0400

    git: Do not ignore certtool templates.
    
    This effectively reverts part of
    dc85966364994006f9337e4749d1487e4b8e16a1 in order to ensure that
    tests/cert-tests/templates/*.tmpl are not ignored by git.
    
    Closes: #1242
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Mon May 17 13:20:26 2021 -0400

    tests/cert-tests: test a policy without any policyQualifiers.
    
    Ensure that a policy without policyQualifiers gets created with an
    omitted sequence of qualifiers, rather than an empty sequence of
    qualifiers.
    
    We use NIST's test policy OID for this test.
    
    This tests the fix for #1238.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Fri May 14 17:57:54 2021 -0400

    x509: Omit empty sequences of policyQualifiers.
    
    When a certificate has a policy attached but no policyQualifiers,
    `certtool` should omit the policyQualifiers sequence entirely, rather
    than emitting an empty sequence.
    
    Closes: #1238
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri May 14 15:59:37 2021 +0200

    cert auth: filter out unsupported cert types from TLS 1.2 CR
    
    When the server is advertising signature algorithms in TLS 1.2
    CertificateRequest, it shouldn't send certificate_types not backed by
    any of those algorithms.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 17 07:58:43 2021 +0200

    pre_shared_key: limit 0-RTT to resumption connections
    
    While RFC 8446 allows 0-RTT data in a non-resumption connection
    established with external PSK, it requires a mechanism to associate
    encryption parameters with PSK.  Until we provide a new API for that,
    let's limit the 0-RTT use to resumption connections only.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Wed May 12 20:49:20 2021 -0400

    x509: Write keyUsage extension with minimal BIT STRING
    
    Avoid embedding trailing cleared bits in the BIT STRING for the
    keyUsage extension.
    
    The overwhelming majority of this changeset is correcting the
    artifacts in the test suite, most of which had keyUsage with a
    non-minimal encoding.  The only functional code change is in
    lib/x509/x509_ext.c.
    
    Closes: #1236
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri May 14 08:48:24 2021 +0200

    .gitlab-ci.yml: add bootstrap stage
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri May 14 08:26:37 2021 +0200

    serv: stop setting AI_ADDRCONFIG on getaddrinfo
    
    AI_ADDRCONFIG is only useful when the NODE argument is given in the
    getaddrinfo call, as described in RFC 3493 6.1.  Suggested by Andreas
    Metzler in:
    https://gitlab.com/gnutls/gnutls/-/issues/1007#note_356637206
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu May 13 15:03:10 2021 +0200

    configure.ac: specify -ladvapi32 in mingw builds
    
    This library needs to be linked for CryptAcquireContextW, used in
    lib/system/keys-win.c.  Suggested by Tim Kosse in:
    https://gitlab.com/gnutls/gnutls/-/issues/1232
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 09:50:22 2021 +0200

    tests: don't install crypt32.dll and ncrypt.dll replacement
    
    Reported by Tim Kosse in:
    https://gitlab.com/gnutls/gnutls/-/issues/1232
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 29 18:44:28 2021 +0200

    gnutls_early_{cipher,prf_hash}_get: new functions
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 29 11:50:00 2021 +0200

    tests: rework tls13-early-data to check key scheduling
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 29 18:25:55 2021 +0200

    tests: tls13-early-data: use TLS_CHACHA20_POLY1305_SHA256
    
    When resuming in TLS 1.3, the negotiated PRF hash must match the one
    used in the initial handshake.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 29 18:09:01 2021 +0200

    tests: remove shell-script wrapper for tls13/prf-early
    
    The wrapper (tls13/prf-early.sh) was merely for running
    tls13/prf-early under datefudge.  The same thing can now be done with
    virt_time_init_at.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 29 17:56:37 2021 +0200

    tests: virt-time: add virt_time_init_at
    
    This allows the tests to set the current time to arbitrary point,
    instead of the current time; useful for the tests checking the traces
    such as tls13/prf-early.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 29 08:35:02 2021 +0200

    gnutls_init: add flag to omit EndOfEarlyData messages
    
    The message is prohibited in QUIC:
    https://tools.ietf.org/html/draft-ietf-quic-tls-34#section-8.3
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 29 08:26:46 2021 +0200

    gnutls_init: redefine GNUTLS_ENABLE_EARLY_DATA flag for client
    
    The flag was only for the server, but it turned out to be useful for
    client to explicitly indicate early data, when 0-RTT is handled
    out-of-band as in QUIC.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 29 08:23:15 2021 +0200

    state: call secret_func on early write key change as well
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu May 13 08:38:20 2021 +0200

    .gitlab-ci.yml: doc-dist.Fedora: invoke "texconfig rehash"
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu May 13 08:01:27 2021 +0200

    systemkey: remove unused --inder and --infile options
    
    While those options have no effect, the command previously tried to
    open a file for reading and leaked file descriptor.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed May 12 16:55:37 2021 +0200

    keylog: suppress -Wanalyzer-file-leak warnings
    
    This workarounds the following warnings with gcc analyzer:
    
      kx.c:156:69: error: leak of FILE '<unknown>' [CWE-775] [-Werror=analyzer-file-leak]
        156 |                         _gnutls_bin2hex(session->security_parameters.
            |                                         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~^
        157 |                                         client_random, GNUTLS_RANDOM_SIZE,
            |                                         ~~~~~~~~~~~~~
    
    This should be harmless because the keylog file pointer is closed in
    the ELF destructor.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed May 12 14:46:56 2021 +0200

    .gitlab-ci.yml: update build images to Fedora 34 and Alpine 3.13
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed May 12 14:44:37 2021 +0200

    devel: regenerate abidw dump files
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 15:29:03 2021 +0200

    .gitlab-ci.yml: bump cache version
    
    This should fix the nettle_streebog512_update detection.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 14:25:38 2021 +0200

    srptool: add missing fclose on error path
    
    Spotted by gcc analyzer:
      srptool.c:113:32: warning: leak of FILE 'fp' [CWE-775] [-Wanalyzer-file-leak]
        113 |                         return -1;
            |                                ^
    also:
      srptool.c:560:32: warning: leak of FILE 'fp' [CWE-775] [-Wanalyzer-file-leak]
        560 |                         return -1;
            |                                ^
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu May 13 08:40:59 2021 +0200

    tests: _check_wait_status: use only async-thread-safe function
    
    As this function shall be called in a signal handler, it shouldn't use
    'exit' as it's not async-thread-safe.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 14:23:45 2021 +0200

    gnutls-serv: use only async-signal-safe functions in signal handler
    
    Spotted by gcc analyzer:
      serv.c:1138:9: warning: call to 'exit' from within signal handler [CWE-479] [-Wanalyzer-unsafe-call-within-signal-handler]
       1138 |         exit(1);
            |         ^~~~~~~
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 14:13:45 2021 +0200

    certtool: tighten allocation check
    
    Spotted by gcc analyzer:
      certtool-cfg.c:856:24: warning: use of possibly-NULL 'copy' where non-null expected [CWE-690] [-Wanalyzer-possible-null-argument]
        856 |                 while (strcmp(pass, copy) != 0
            |                        ^~~~~~~~~~~~~~~~~~
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 14:08:33 2021 +0200

    psktool: tighten allocation check
    
    Spotted by gcc analyzer:
      psk.c:275:21: warning: use of possibly-NULL '_username.data' where non-null expected [CWE-690] [-Wanalyzer-possible-null-argument]
        275 |                 if (strncmp(p, (const char *) _username.data,
            |                     ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 13:16:51 2021 +0200

    .gitignore: ignore more files
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 11:08:59 2021 +0200

    _tls13_{derive,expand}_secret2: fix array parameter mismatch
    
    This suppresses the warning with -Warray-parameter
      secrets.c:85:40: warning: argument 6 of type 'const uint8_t[64]' {aka 'const unsigned char[64]'} with mismatched bound [-Warray-parameter=]
         85 |                          const uint8_t secret[MAX_HASH_SIZE],
            |                          ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
      In file included from secrets.c:28:
      secrets.h:43:41: note: previously declared as 'const uint8_t[32]' {aka 'const unsigned char[32]'}
         43 |                           const uint8_t secret[MAX_CIPHER_KEY_SIZE],
            |                           ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 11 11:04:54 2021 +0200

    _gnutls_retrieve_pin: remove array declarator in function argument
    
    This was originally to eliminate the warnings with -Warray-parameter:
    
      pin.c:70:27: warning: argument 5 of type 'char[256]' with mismatched bound [-Warray-parameter=]
         70 |                      char pin[GNUTLS_PKCS11_MAX_PIN_LEN], unsigned pin_size)
            |                      ~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      In file included from pin.c:23:
      ./pin.h:9:48: note: previously declared as 'char *'
          9 |                      unsigned pin_flags, char *pin, unsigned pin_size);
            |                                          ~~~~~~^~~
    
    though it turned out to be unnecessary because the function merely
    delegate the call to the user-supplied callbacks.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Wed May 5 18:05:29 2021 -0400

    spelling: The possessive pronoun "its" has no apostrophe.
    
    "it's" is for contractions like "it is" or "it has".  "its" is a
    possessive pronoun, like "his" or "hers" or "theirs", none of which
    have an apostrophe in them either.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Date:   Tue May 4 15:08:08 2021 -0400

    certtool: Align warning about --provable with actual code
    
    If I try to generate an ed25519 key, it is *not* an ECDSA key.  But I
    see this warning:
    
        0 dkg@host:~$ certtool --generate-privkey --provable --key-type ed25519
        Generating a 256 bit EdDSA (Ed25519) private key ...
        The --provable parameter cannot be used with ECDSA keys.
        1 dkg@host:~$
    
    Looking at the code and documentation, it's clear that --provable only
    works for RSA and DSA.  This fix aligns the warning message with the
    underlying mechanism.
    
    Signed-off-by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 3 16:35:43 2021 +0200

    x509/verify: treat SHA-1 signed CA in the trusted set differently
    
    Suppose there is a certificate chain ending with an intermediate CA:
    EE → ICA1 → ICA2.  If the system trust store contains a root CA
    generated with the same key as ICA2 but signed with a prohibited
    algorithm, such as SHA-1, the library previously reported a
    verification failure, though the situation is not uncommon during a
    transition period of root CA.
    
    This changes the library behavior such that the check on signature
    algorithm will be skipped when examining the trusted root CA.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 3 17:27:56 2021 +0200

    global: rename GNUTLS_NO_EXPLICIT_INIT to GNUTLS_NO_IMPLICIT_INIT
    
    The old envvar still has effect but has been marked as deprecated.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 3 14:19:22 2021 +0200

    certtool: fix parsing of --verify-profile option
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Ruslan N. Marchenko <me@ruff.mobi>
Date:   Sun May 2 23:29:39 2021 +0200

    Add tests for call gnutls_session_channel_binding
    
     Add test unit which executes positive and negative test scenarios
     using standard gnutls testing framework.
    
    Signed-off-by: Ruslan N. Marchenko <me@ruff.mobi>

Author: Ruslan N. Marchenko <me@ruff.mobi>
Date:   Sat May 1 23:05:54 2021 +0200

    Add tls-server-end-point tls channel binding implementation.
    
     Add server-end-point tls channel binding into gnutls_session_channel_binding
     method. The implementation extracts session's certificate, its signature
     algorithm, and calculates digest of the extracted certificate using
     the function based on extracted algorithm, as per RFC5929.
    
    Signed-off-by: Ruslan N. Marchenko <me@ruff.mobi>

Author: Ruslan N. Marchenko <me@ruff.mobi>
Date:   Sat May 1 10:16:37 2021 +0200

    Restructure gnutls_session_channel_binding and add tls-exporter
    
     The restructure removes explicit pre-check for supported binding
     type(s) and instead relies now on catch-all return which returns
     UNIMPLEMENTED_FEATURE if no type was handled. In addition to that
     it returns UNIMPLEMENTED_FEATURE for tls-unique request on TLSv1.3
     session, since that is not supposed to work hence requires explicit
     error. Finally new binding type tls-exporter implementation is
     added.
    
    Signed-off-by: Ruslan N. Marchenko <me@ruff.mobi>

Author: Ruslan N. Marchenko <me@ruff.mobi>
Date:   Sat May 1 10:22:14 2021 +0200

    Introduce new tls channel binding types into gnutls_channel_binding_t
    
     This commit adds two new tls channel binding types into enum
     gnutls_channel_binding_t:
     * tls-server-end-point
     * tls-exporter
    
    Signed-off-by: Ruslan N. Marchenko <me@ruff.mobi>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Apr 28 11:04:20 2021 +0200

    certtool: don't copy CRL distribution point from CA cert
    
    Suggested by Thomas Karlsson in:
    https://gitlab.com/gnutls/gnutls/-/issues/1126
    
    While this changes the default behavior, CDP can always be set through
    the template or interactive input.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 25 17:04:46 2021 +0200

    gnutls_x509_crt_get_dn: clarify null-termination of the output
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 25 10:48:09 2021 +0200

    build: do not install .hmac files
    
    It turned out that distro package building process might perform
    post-processing (e.g., strip) of the shared libraries after install,
    and that may cause inconsistency with the installed .hmac files.
    
    Let's not try too hard on this but defer the final hmac calculation to
    distributions.  It is still useful to keep our own fipshmac as it
    makes it easier to run FIPS tests.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 25 06:51:20 2021 +0200

    tests: fix test script file name in distribution
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 25 06:50:03 2021 +0200

    .gitignore: ignore ctags, etags, and GNU global files
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 23 15:36:37 2021 +0200

    handshake: fix timing of sending early data
    
    Previously, the client was sending early data after receiving a Server
    Hello message, which not only negates the benefit of 0-RTT, but also
    was a logic error as it can only be decrypted by the server when the
    initial handshake and the resuming handshake agree on the same
    ciphersuites.  This fixes that behavior in the following ways:
    
    - extend the session data format to include the selected ciphersuites,
      even in TLS 1.3
    - setup the epoch for early data, right before the client sending
      early data (also right after the server deciding to accept early
      data).
    - extend the test case to use different ciphersuites in the initial
      and resuming handshakes
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Fri Apr 23 09:44:20 2021 +0200

    guile: Tests show their PID upon uncaught exceptions.
    
    * guile/modules/gnutls/build/tests.scm (run-test): Display the PID when
    throwing an exception.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Fri Feb 5 12:28:35 2021 +0100

    guile: Avoid the deprecated 'scm_t_uint8' type.
    
    * guile/src/core.c: Use 'uint8_t' instead of 'scm_t_uint8', which is
    deprecated in Guile 3.0.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Tue Dec 22 10:30:43 2020 +0100

    guile: Avoid potentially missed reference.
    
    There's one case where 'register_weak_reference' is called several times
    on the same object, in 'set-certificate-credentials-x509-keys!', where
    PRIVKEY could have been GC'd before CRED.
    
    * guile/src/core.c (register_weak_reference): Add TO to the weak
    references of FROM instead of overriding them.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 23 10:28:03 2021 +0200

    afalg: use pkg-config to detect libkcapi
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 23 10:03:47 2021 +0200

    afalg: support AES-XTS algorithms
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 23 09:56:40 2021 +0200

    afalg: cleanup header inclusion
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Ludovic Courtès <ludo@gnu.org>
Date:   Mon Dec 21 18:22:14 2020 +0100

    guile: Remove leftover comment about allocation routines.
    
    This is a followup to 872409857351f28b1e3c21526bfa6606c918b176.
    
    * guile/src/core.c (scm_init_gnutls): Remove leftover comment.
    
    Signed-off-by: Ludovic Courtès <ludo@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 23 09:50:16 2021 +0200

    afalg: remove unnecessary initialization
    
    That would make it easier to spot any uninitialized memory access with
    valgrind.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 23 09:45:51 2021 +0200

    afalg: assert IV size returned from the kernel is in the range
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 23 09:42:03 2021 +0200

    NEWS: mention AF_ALG support
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Apr 14 17:27:43 2021 +0200

    crypto-selftests: tolerate errors of gnutls_{hash,hmac}_copy
    
    Some hardware accelerated implementations, such as afalg, cannot
    support the copy operation.  This patch turns it a soft-error, as the
    code below is already checking if the copy is non-NULL, before
    performing any operation on it.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 22 16:42:01 2021 +0200

    handshake: don't regenerate legacy_session_id in second CH after HRR
    
    According to RFC 8446 4.1.2, the client must send the same Client
    Hello after Hello Retry Request, except for the certain extensions,
    and thus legacy_session_id must be preserved.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Apr 14 16:50:28 2021 +0200

    _gnutls_cipher_init: fallback if setiv is not implemented for AEAD
    
    The _gnutls_cipher_init function currently assumes that all the cipher
    implementations have .setiv method.  This is not the case for
    AEAD-only implementations such as afalg.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Stephan Mueller <smueller@chronox.de>
Date:   Sat Oct 14 20:46:09 2017 +0200

    Add AF_ALG acceleration
    
    The patch set adds the backend implementation to use the Linux kernel
    crypto API via the AF_ALG interface. The GnuTLS AF_ALG extension uses
    libkcapi [1] as the backend library which implements the actual kernel
    communication.
    
    [1] http://www.chronox.de/libkcapi.html
    
    The symmetric cipher support, the hashing and the MAC support are
    validated to work correctly using NIST CAVS test vectors.
    
    The AEAD cipher support was tested by connecting to a remote host using
    gnutls-cli (the following log strips out unrelated information):
    
    Processed 143 CA certificate(s).
    ...
    - Certificate type: X.509
    - Got a certificate list of 1 certificates.
    - Certificate[0] info:
    ...
    - Description: (TLS1.2)-(ECDHE-SECP384R1)-(RSA-SHA512)-(AES-256-GCM)
    - Session ID: 9E:5E:FC:09:2A:4E:2A:3D:22:44:68:42:C3:F6:2D:AB:F9:67:08:CE:6D:EE:E4:A2:EF:80:43:FE:3B:D9:1E:FE
    - Ephemeral EC Diffie-Hellman parameters
     - Using curve: SECP384R1
     - Curve size: 384 bits
    - Version: TLS1.2
    - Key Exchange: ECDHE-RSA
    - Server Signature: RSA-SHA512
    - Cipher: AES-256-GCM
    - MAC: AEAD
    - Options: extended master secret, safe renegotiation,
    - Handshake was completed
    
    - Simple Client Mode:
    
    Signed-off-by: Stephan Mueller <smueller@chronox.de>
    
    Co-authored-by: Daiki Ueno <ueno@gnu.org>
    Co-authored-by: Hedgehog5040 <krenzelok.frantisek@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Apr 16 13:56:40 2021 +0200

    priority: add option to disable TLS 1.3 middlebox compatibility mode
    
    This adds a new option %DISABLE_TLS13_COMPAT_MODE to disable TLS 1.3
    compatibility mode at run-time.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Mar 30 13:39:46 2021 +0200

    _gnutls_calloc: remove unused function
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 29 14:09:51 2021 +0200

    keys-win: free certificate context in gnutls_system_key_iter_deinit
    
    Suggested by Bjørn Christensen in:
    https://gitlab.com/gnutls/gnutls/-/issues/1197
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 29 11:06:37 2021 +0200

    build: avoid integer overflow in additions
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Feb 21 08:43:26 2021 +0100

    build: avoid potential integer overflow in array allocation
    
    This relies on _gnutls_reallocarray for all occasions of array
    allocations, so that they can benefit from the built-in overflow
    checks.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 29 13:08:23 2021 +0200

    pkcs11x: find_ext_cb: fix error propagation
    
    Use explicit error value, as rv is not set in this code path.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Feb 21 08:42:23 2021 +0100

    mem: add _gnutls_reallocarray and _gnutls_reallocarray_fast
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Feb 21 08:34:13 2021 +0100

    bootstrap: pull in 'xalloc-oversized' module from Gnulib
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Sat Mar 20 13:52:25 2021 +0100

    build: doc: install missing image file gnutls-crypto-layers.png
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 15 11:03:44 2021 +0100

    examples: avoid memory leak in ex-verify
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 15 11:03:22 2021 +0100

    examples: avoid memory leak in tlsproxy
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 15 10:56:46 2021 +0100

    src: avoid file descriptor leak in socket_open2
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 15 10:48:49 2021 +0100

    gnutls-cli-debug: avoid resource leak in saving DHE params
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 15 10:47:50 2021 +0100

    srptool: avoid FILE pointer leak on error
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 15 09:55:20 2021 +0100

    gnulib: update git submodule
    
    This brings in the fix for parse-datetime test failures on NetBSD:
    https://lists.gnu.org/archive/html/bug-gnulib/2021-03/msg00069.html
    https://git.savannah.gnu.org/gitweb/?p=gnulib.git;a=commit;h=35f8ff2e1162bf3ee60d99b6812f2ae10f3f2898
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Mar 10 16:12:23 2021 +0100

    str: suppress -Wunused-function if AGGRESSIVE_REALLOC is defined
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Mar 10 16:11:29 2021 +0100

    _gnutls_buffer_resize: account for unused area if AGGRESSIVE_REALLOC
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Mar 10 05:06:13 2021 +0100

    Release 3.7.1
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 29 14:06:50 2021 +0100

    pre_shared_key: avoid use-after-free around realloc
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 29 14:06:32 2021 +0100

    key_share: avoid use-after-free around realloc
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Mar 9 13:41:59 2021 +0100

    _gnutls_buffer_resize: add option to use allocation simpler logic
    
    This helps detect common mistakes[1] in realloc usage with valgrind,
    where the caller assumes that the original ptr is always returned.
    
    1. https://bugzilla.mozilla.org/show_bug.cgi?id=1377618
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>
    Co-authored-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Mar 9 20:29:37 2021 +0100

    x86: flip polarity of check_fast_pclmul
    
    Otherwise GCC produces the following warnings as the stub
    __get_cpuid() is defined as '#define __get_cpuid(...) 0':
    
    x86-common.c: In function 'register_x86_crypto':
    x86-common.c:314:15: warning: 'a' may be used uninitialized in this function [-Wmaybe-uninitialized]
      314 |  family = ((a >> 8) & 0x0F);
          |            ~~~^~~~~
    x86-common.c:308:15: note: 'a' was declared here
      308 |  unsigned int a,b,c,d;
          |               ^
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Mar 9 13:07:26 2021 +0100

    gnutls_buffer_append_data: remove duplicated code
    
    The function shared the same logic as in _gnutls_buffer_resize.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Mar 8 14:56:32 2021 +0100

    lib/nettle: get rid of _rnd_system_entropy_check
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Mon Mar 8 11:54:16 2021 +0100

    lib/global: don't call now-noop _gnutls_rnd_check
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Thu Mar 4 10:54:44 2021 +0100

    sysrng-linux: re-open /dev/urandom every time
    
    Prompted by the following comment of Daiki Ueno:
    > I also wonder why we keep the fd open for such a long time in the first
    > place. Both OpenSSL and NSS have a similar fallback to /dev/urandom
    > if getrandom is not available, but opens the device in one-shot,
    > when reseeding is needed (and that's pretty rare).
    https://gitlab.com/gnutls/gnutls/-/merge_requests/1383#note_521749519
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Steffen Jaeckel <jaeckel-floss@eyet-services.de>
Date:   Fri Mar 5 12:31:45 2021 +0100

    Add unit test for id-on-xmppAddr decoding error
    
    Signed-off-by: Steffen Jaeckel <jaeckel-floss@eyet-services.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Mar 5 12:08:25 2021 +0100

    gnutls_x509_trust_list_verify_crt2: skip duped certs for PKCS11 too
    
    The commit 09b40be6e0e0a59ba4bd764067eb353241043a70 (part of
    gnutls/gnutls!1370) didn't cover the case where the trust store is
    backed by PKCS #11, because it used _gnutls_trust_list_get_issuer,
    which only works with file based trust store.
    
    This patch replaces the call with more generic
    gnutls_x509_trust_list_get_issuer so it also works with other trust
    store implementations.
    
    Reported by Michal Ruprich.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Steffen Jaeckel <jaeckel-floss@eyet-services.de>
Date:   Thu Mar 4 16:44:21 2021 +0100

    output UTF-8 decoded id-on-xmppAddr SAN's
    
    tls_x509_crt_get_subject_alt_name()` makes a promise [1] "If an
    otherName OID is known, the data will be decoded. ... RFC 3920
    id-on-xmppAddr SAN is recognized." which it didn't hold.
    
    Before this patch the output was still in DER format, e.g. for a
    id-on-xmppAddr which is always UTF-8 (0x0c): `0x0c <len> <xmppAddr>`
    
    This patch fixes the issue and now it returns the decoded string.
    
    [1]
    https://www.gnutls.org/manual/gnutls.html#gnutls_005fx509_005fcrt_005fget_005fsubject_005falt_005fname
    
    Signed-off-by: Steffen Jaeckel <jaeckel-floss@eyet-services.de>

Author: Tom Vrancken <dev@tomvrancken.nl>
Date:   Sun Feb 28 13:56:21 2021 +0100

    Changed _gnutls_session_cert_type_supported prototype and name to follow guidelines for boolean functions.
    
    Signed-off-by: Tom Vrancken <dev@tomvrancken.nl>

Author: Tom Vrancken <dev@tomvrancken.nl>
Date:   Thu Feb 25 12:06:55 2021 +0100

    Changed certificate retrieval callback prototype parameter name to be in line with the other parameters.
    
    Signed-off-by: Tom Vrancken <dev@tomvrancken.nl>

Author: Tom Vrancken <dev@tomvrancken.nl>
Date:   Sat Jan 23 19:24:46 2021 +0100

    Added documentation for rawpk use in certificate retrieval callback.
    
    Signed-off-by: Tom Vrancken <dev@tomvrancken.nl>

Author: Tom Vrancken <dev@tomvrancken.nl>
Date:   Thu Feb 25 15:20:05 2021 +0100

    Added extra logging and done some variable refactoring for server cert type extension.
    
    Signed-off-by: Tom Vrancken <dev@tomvrancken.nl>

Author: Tom Vrancken <dev@tomvrancken.nl>
Date:   Thu Jan 28 20:05:51 2021 +0100

    Added extra logging and done some variable refactoring for client cert type extension.
    
    Signed-off-by: Tom Vrancken <dev@tomvrancken.nl>

Author: JonasZhou <JonasZhou@zhaoxin.com>
Date:   Thu Feb 25 15:48:36 2021 +0800

    padlock:add support for AES-192-CBC
    
    Padlock code misses support for AES-192. Extend it to support AES-192.
    Due to poor performance of padlock-aes-xxx-gcm, only padlock-aes-192-cbc
    is added.
    
    Signed-off-by: JonasZhou <JonasZhou@zhaoxin.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Feb 19 15:36:48 2021 +0100

    .gitlab-ci.yml: run fedora-valgrind jobs only on upstream branches
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jan 30 18:35:14 2021 +0100

    tests: remove *hello_random_value tests
    
    Those tests are meaningless and merely introduces extra flakiness, now
    that the uninitialized random bytes are detected by valgrind.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jan 30 13:34:40 2021 +0100

    .gitlab-ci.yml: use longer handshake timeout for valgrind jobs
    
    Also limit the parallelism to $(nproc) to be less resource intensive.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jan 30 18:22:18 2021 +0100

    tests: make any ad-hoc timeout setting controllable through envvar
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jan 30 10:49:07 2021 +0100

    tests: suffix .sh for all shell-script tests
    
    Otherwise valgrind will run against /bin/sh.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jan 30 09:23:02 2021 +0100

    tests: don't conditionalize valgrind with --disable-full-test-suite
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 29 15:36:44 2021 +0100

    tests: don't run shell-script tests under valgrind
    
    https://www.gnu.org/software/gnulib/manual/html_node/Valgrind-and-shell-scripts.html
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jan 30 09:25:06 2021 +0100

    nettle: check lib state early to cope with synthesized error
    
    tests/x509sign-verify-error.c calls _gnutls_lib_simulate_error before
    the actual private key operations.  That previously resulted in
    infloop / conditional jump depending on uninitialized data, because
    the random function (gnutls_rnd) was not able to feed sufficient
    randomness in that case.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 29 14:09:17 2021 +0100

    tests: fix memory leak in tests/tls13/no-auto-send-ticket
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jan 24 07:49:34 2021 +0100

    tests: remove init_fds test
    
    This test does nothing to expose the original problem linked in the comment:
    https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=760476
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jan 23 14:36:57 2021 +0100

    safe-memfuncs: rely on explicit_bzero implementation from gnulib
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Feb 17 11:31:23 2021 +0100

    .gitlab-ci.yml: remove scriptlet to generate HMAC files for FIPS
    
    This is now generated automatically during the build.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Ondrej Moris <omoris@redhat.com>
Date:   Fri Oct 30 20:43:56 2020 +0100

    fips: replace fipshmac usage with internal program
    
    This introduces a non-installed program "fipshmac" and uses it for
    generating HMAC files required in FIPS 140-2.  The generated files are
    installed along with the main library.
    
    Resolves issues #1101.
    
    Signed-off-by: Ondrej Moris <omoris@redhat.com>
    Co-authored-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Feb 17 07:24:27 2021 +0100

    build: don't remove distributed stamp files on "make clean"
    
    Those files are created by the maintainers and should remain after
    "make clean" when the distribution tarball is used.
    
    Reported by christian wagner in:
    https://gitlab.com/gnutls/gnutls/-/issues/1088
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Feb 16 08:45:23 2021 +0100

    fastopen: remove call to abort()
    
    Ideally, this function should have a way to return an error, but
    simply not enabling TFO wouldn't hurt.
    
    Reported by Tim Rühsen in:
    https://gitlab.com/gnutls/gnutls/-/issues/603
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Feb 16 08:39:17 2021 +0100

    hex: use a table to avoid meaningless assertion
    
    Reported by Tim Rühsen in:
    https://gitlab.com/gnutls/gnutls/-/issues/604
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Feb 17 06:38:41 2021 +0100

    gnutlsxx: add const and explicit specifiers where possible
    
    Flagged by cppcheck.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Dmitriy Tsvettsikh <dmitrycvet@gmail.com>
Date:   Wed Feb 17 04:28:47 2021 +0500

    configure.ac: fix "nettle_rsa_sec_decrypt" check error
    
    When libhogweed built with external gmplib, then it required explicit
    path to gmplib to pass check.
    
    Signed-off-by: Dmitriy Tsvettsikh <dmitrycvet@gmail.com>

Author: Evgeny Grin <k2k@narod.ru>
Date:   Sun Jan 10 21:36:18 2021 +0300

    Sockets: implement sendmsg()-like functions on Win32
    
    Use WSASend() to send several buffer per one sys-call.
    Unified send()/recv() support for POSIX/Win32.
    
    Signed-off-by: Evgeny Grin <k2k@narod.ru>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Feb 16 07:51:10 2021 +0100

    gnutlsxx: dh_params, rsa_params: actually assign values in operator=
    
    The previous implementation assigned the value to a temporary variable
    and then return it without assigning it to 'this'.  That is not only
    contradictory to user's expectation but also cppcheck treats it as a
    logic error.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Feb 15 15:51:25 2021 +0100

    README.md: don't suggest installing lockfile-progs
    
    The dependency has been removed in
    5eff2002b0f7ac54b14326f207b5a9e509269555.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Feb 15 14:54:14 2021 +0100

    .gitlab-ci.yml: fix typo in cppcheck -I argument
    
    Reported by Tim Rühsen in:
    https://gitlab.com/gnutls/gnutls/-/issues/705
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Feb 15 14:53:39 2021 +0100

    README.md: fix typo in libev URL
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Feb 13 15:56:22 2021 +0100

    .gitlab-ci.yml: bump cache version
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Feb 8 12:24:31 2021 +0100

    bootstrap.conf: initialize openssl submodule
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Feb 8 08:46:13 2021 +0100

    configure.ac: fix misleading --help output on guile bindings
    
    Reported by Tim Rühsen in:
    https://gitlab.com/gnutls/gnutls/-/issues/577
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Feb 7 18:54:45 2021 +0100

    bootstrap: update from Gnulib
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Feb 7 17:38:31 2021 +0100

    bootstrap.conf: refactor detection of gtk-doc and gnulib sockets
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Feb 13 15:57:36 2021 +0100

    .gitignore: ignore more files
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Tue Feb 9 14:16:54 2021 +0100

    Fix test error with nettle in non-default location
    
    Move #include <nettle/memxor.h> from gnutls_int.h to lib/cipher.c, drop
    now superfluous NETTLE_CFLAGS from CPPFLAGS of multiple tests #including
    gnutls_int.h.
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 11 06:45:47 2021 +0100

    .gitlab-ci.yml: remove FreeBSD run
    
    This used to run on a dedicated FreeBSD runner, which is no longer
    maintained.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Feb 9 15:26:07 2021 +0100

    tests/gnutls-cli-debug.sh: don't unset system priority settings
    
    When the test is exercised, GNUTLS_SYSTEM_PRIORITY_FILE is set in many
    places, such as TESTS_ENVIRONMENT tests/Makefile.am or a packaging
    system that runs the test in a restricted environment.  Unsetting it
    after a temporary use forces the remaining part of the test to use the
    default system priority, which might not be the intention of the user.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Dec 28 12:14:13 2020 +0100

    gnutls_x509_trust_list_verify_crt2: ignore duplicate certificates
    
    The commit ebb19db9165fed30d73c83bab1b1b8740c132dfd caused a
    regression, where duplicate certificates in a certificate chain are no
    longer ignored but treated as a non-contiguous segment and that
    results in calling the issuer callback, or a verification failure.
    
    This adds a mechanism to record certificates already seen in the
    chain, and skip them while still allow the caller to inject missing
    certificates.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>
    Co-authored-by: Andreas Metzler <ametzler@debian.org>

Author: Dosenpfand <m@sad.bz>
Date:   Sun Feb 7 23:17:28 2021 +0100

    doc: Add some missing algorithm keywords to priority string table
    
    Signed-off-by: Markus Gasser <m@sad.bz>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Feb 3 16:05:22 2021 +0100

    tests: close unused fd opened by socketpair
    
    Otherwise the tests block forever, even if the child exits.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Feb 3 15:56:42 2021 +0100

    .gitlab-ci.yml: remove redundant "make check" in build stage
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jan 24 07:34:24 2021 +0100

    handshake: TLS 1.3: don't generate session ID in resumption mode
    
    The commit e0bb98e1f71f94691f600839ff748d3a9f469d3e revealed that the
    previous code always generated session ID in the TLS 1.3 middlebox
    compatibility mode even when the handshake is being resumed.
    
    This could cause a difference in PSK binder calculation if the server
    sends an HRR in the resumption handshake.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Feb 3 15:50:08 2021 +0100

    gnutls_session_is_resumed: don't check session ID in TLS 1.3
    
    In middlebox compatibiltiy mode, TLS 1.3 client simulates the TLS 1.2
    resumption handshake, so checking session ID for resumption is
    pointless.  This worked previously because the client always generated
    new random value even in a true resumption handshake, but didn't
    update the session parameters properly.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 4 08:39:04 2021 +0100

    _gnutls_openpgp_send_fingerprint: remove unused declaration
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 4 08:38:16 2021 +0100

    _gnutls_session_is_resumable: remove unused internal function
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 4 08:56:33 2021 +0100

    handshake: replace TRUE and FALSE with <stdbool.h>
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Feb 4 08:30:30 2021 +0100

    handshake: replace RESUME_TRUE and RESUME_FALSE with <stdbool.h>
    
    Having those constants could cause wrong impression that there is a
    third possible value.
    
    To reproduce the changes other than lib/gnutls_int.h:
    
      for i in `git ls-files lib`; do
          sed -i
              -e 's/\(session->internals.\(resumed\|resumable\)\) *\(== *RESUME_FALSE\|!= *RESUME_TRUE\)/!\1/' \
              -e 's/\(session->internals.\(resumed\|resumable\)\) *\(== *RESUME_TRUE\|!= *RESUME_FALSE\)/\1/' \
              -e 's/RESUME_TRUE/true/' \
              -e 's/RESUME_FALSE/false/' \
          $i
      done
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Dec 29 09:59:06 2020 +0100

    testcompat-openssl: run TLS 1.3 client/server tests in parallel
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Dec 29 07:26:16 2020 +0100

    testcompat-openssl: remove hand-written parallelism
    
    Previously, the test used to launch multiple tests in background and
    then join them using shell primitives.  That approach makes the test
    slower as it cannot benefit from the automake's parallel test harness,
    as well as it makes diagnostic harder because the lines in the log
    file mix up.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Dec 29 10:06:50 2020 +0100

    testcompat-polarssl: remove hand-written parallelism
    
    Previously, the test used to launch multiple tests in background and
    then join them using shell primitives.  That approach makes the test
    slower as it cannot benefit from the automake's parallel test harness,
    as well as it makes diagnostic harder because the lines in the log
    file mix up.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jan 22 14:37:47 2021 +0100

    fips: avoid memleak in (EC)DH internal APIs
    
    There were some confusions of gnutls_pk_params_clear and
    gnutls_pk_params_release, as well as the number of parameters to scan
    in the gnutls_pk_params_st structure.
    
    Flagged by address sanitizer:
      ==354688==ERROR: LeakSanitizer: detected memory leaks
    
      Direct leak of 192 byte(s) in 12 object(s) allocated from:
          #0 0x7f13506163cf in __interceptor_malloc (/lib64/libasan.so.6+0xab3cf)
          #1 0x7f13503b94de in wrap_nettle_mpi_init /home/ueno/devel/gnutls/lib/nettle/mpi.c:79
          #2 0x7ffcb8495f07  ([stack]+0x1ef07)
    
      Direct leak of 160 byte(s) in 10 object(s) allocated from:
          #0 0x7f13506163cf in __interceptor_malloc (/lib64/libasan.so.6+0xab3cf)
          #1 0x7f13503b94de in wrap_nettle_mpi_init /home/ueno/devel/gnutls/lib/nettle/mpi.c:79
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Tom Carroll <incentivedesign@gmail.com>
Date:   Sun Jan 10 15:28:50 2021 -0800

    Deinitialize pcerts array elements during cleanup.
    
    In gnutls_certificate_set_x509_key() cleanup, the pcert elements should
    be deinitialized, freeing pcert's pubkey and cert fields.
    
    Signed-off-by: Tom Carroll <incentivedesign@gmail.com>

Author: Tom Carroll <incentivedesign@gmail.com>
Date:   Sun Jan 10 21:40:52 2021 -0800

    Ensure ca_list != NULL and ca_list_size > 0.
    
    As ca_list_size is used in malloc, ensure that ca_list_size > 0.
    If ca_list_size > 0, then ca_list cannot be NULL. Make these
    assumptions explicit with argument condition check.
    
    Signed-off-by: Tom Carroll <incentivedesign@gmail.com>

Author: Tom Carroll <incentivedesign@gmail.com>
Date:   Sun Jan 10 21:31:19 2021 -0800

    Verify that cert_list != NULL and cert_list_size > 0.
    
    gnutls_certificate_set_x509_key() assumes that cert_list != NULL and
    cert_list_size > 0.  These assumptions are evident as cert_list_size is
    used for malloc and cert_list[0] is accessed. Make those assumptions
    explicit with argument condition check.
    
    Signed-off-by: Tom Carroll <incentivedesign@gmail.com>

Author: Martin Storsjo <martin@martin.st>
Date:   Thu Jan 7 13:41:12 2021 +0200

    configure: Remove -no_weak_links from LDFLAGS after detecting function availability
    
    This reverts commit 945a48993dcdd9ead17216e55c59db209923ea5e
    and fixes the original issue (#966) differently.
    
    This makes sure that when targeting a version of macOS less than
    10.12, we won't pick up and unconditionally use functions that
    only appeared later, when building with Xcode 11.4 or newer.
    (With Xcode 11.4 or newer, the fix from 945a48993dcdd9 caused
    -no_weak_links not be added, affecting the function availability
    tests.)
    
    Signed-off-by: Martin Storsjo <martin@martin.st>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Thu Jan 7 20:29:54 2021 +0100

    Update year of copyright notices in doc/gnutls.texi
    
    Static analysis in CI checks if this is up to date, and fails if
    not. This fixes the failure.
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Sat Jan 2 18:24:18 2021 +0100

    Update CI documentation for use of Github Actions
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Sat Jan 2 18:22:55 2021 +0100

    Remove Travis CI configuration
    
    Replaced by Github Actions workflow added in
    9fc73ec96fa5adfc8e9a4bd2ee9e6543ffcfe120.
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Tue Dec 29 22:03:53 2020 +0100

    Github Actions job for MacOS CI
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Dec 29 19:24:28 2020 +0100

    gnulib: update git submodule
    
    This brings in the fix for building with autoconf 2.70:
    https://lists.gnu.org/archive/html/bug-gnulib/2020-12/msg00091.html
    
    Suggested by Jan Palus in:
    https://gitlab.com/gnutls/gnutls/-/issues/1138
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Sadie Powell <sadie@witchery.services>
Date:   Fri Dec 11 05:39:56 2020 +0000

    Fix a common typo of gnutls_priority_t.
    
    Signed-off-by: Sadie Powell <sadie@witchery.services>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Tue Dec 8 11:36:57 2020 +0100

    libgnutls-openssl: Clean up list of exported symbols
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Dec 29 09:46:36 2020 +0100

    testcompat-openssl: specify -sigalgs on s_client command line
    
    This is a left-over of commit
    23958322865a8a77c2f924f569484e5fd150a24b. Otherwise the OpenSSL system
    configuration may affect algorithm selection.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Dec 28 16:16:53 2020 +0100

    testpkcs11: use datefudge to trick certificate expiry
    
    The certificates stored in tests/testpkcs11-certs expired on
    2020-12-13.  To avoid verification failure due to that, use datefudge
    to set custom date when calling gnutls-cli, gnutls-serv, and certtool.
    
    Based on the patch by Andreas Metzler:
    https://gitlab.com/gnutls/gnutls/-/issues/1135#note_469682121
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Stefan Berger <stefanb@linux.ibm.com>
Date:   Mon Dec 21 09:36:47 2020 -0500

    tests: Fix tpmtool_test due to changes in trousers
    
    Recent changes to trousers now require an ownership of root:tss for
    the tcsd config file, older ones requires tss:tss. So, start tcsd
    using trial and error with either one of these ownership configurations
    until one works.
    
    Signed-off-by: Stefan Berger <stefanb@linux.ibm.com>

Author: Norbert Pocs <npocs@redhat.com>
Date:   Fri Oct 30 17:18:30 2020 +0100

    Fix non-empty session id (TLS13_APPENDIX_D4)
    
    When TLS1.3 is used with middlebox compatible mode, the session id should be filled with random session id,
    but remained empty.
    
    Signed-off-by: Norbert Pocs <npocs@redhat.com>
    
    Closes #1074

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Dec 2 10:30:08 2020 +0100

    Release 3.7.0
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Dec 2 09:33:21 2020 +0100

    NEWS: update for 3.7.0 release
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: ihsinme <ihsinme@gmail.com>
Date:   Mon Nov 30 14:56:15 2020 +0000

    fix invalid unsigned arithmetic.
    
    Signed-off-by: ihsinme <ihsinme@gmail.com>

Author: Stanislav Zidek <szidek@redhat.com>
Date:   Fri Nov 27 13:24:24 2020 +0100

    CI pipeline rework - using stages and inheritance
    
    Signed-off-by: Stanislav Zidek <szidek@redhat.com>

Author: Michael Catanzaro <mcatanzaro@gnome.org>
Date:   Mon Nov 30 13:08:01 2020 -0600

    x509: Improve documentation of new set_getissuer_function
    
    Since gnutls!1354, some of this information is now obsolete. The caller
    is no longer responsible for verifying the certificate or adding it to
    the trust list. GnuTLS will now handle that. Instead, the callback
    should always import the missing certificate and return success if the
    certificate was imported, or failure otherwise.
    
    Also, let's point to gnutls_x509_crt_get_authority_info_access(), since
    it is useful in combination with this function.
    
    Finally, since this callback is emitted once for each missing
    intermediate certificate, it's probably less confusing if we talk about
    only a single missing intermediate here. Yes, there could be multiple
    missing certificates, but a single invocation of this callback can only
    deal with one.
    
    Signed-off-by: Michael Catanzaro <mcatanzaro@gnome.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Nov 29 18:17:54 2020 +0100

    fuzz: limit the retry count in handshake fuzzer
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Nov 29 17:44:24 2020 +0100

    gnutls_handshake_write: don't enqueue empty Handshake message
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Nov 29 16:51:45 2020 +0100

    fuzz: fix undefined behavior on left shift
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   Tue Nov 24 11:13:07 2020 +0100

    accelerated: Re-generate assembly sources
    
    Re-generate assembly sources from the updated openssl submodule.
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Nov 24 10:54:06 2020 +0100

    verify-tofu: return errors from store functions if callback fails
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   Tue Nov 24 10:46:12 2020 +0100

    devel: Update openssl submodule
    
    Update openssl submodule to current OpenSSL_1_1_1-stable branch
    (8e813c085a).
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Nov 23 07:49:04 2020 +0100

    configure.ac: include <libguile.h> when checking scm_* functions
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Nov 12 06:49:12 2020 +0100

    crypto-backend: remove ability of overriding ciphers
    
    Those functions has been deprecated in 3.6.9 as they do not have
    active use cases.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Nov 9 10:11:04 2020 +0100

    NEWS: add entry for QUIC related API functions
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Nov 9 09:05:05 2020 +0100

    fuzz: fuzz gnutls_handshake_write
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Mar 24 17:51:56 2020 +0100

    alert: add callback to intercept alert messages
    
    This adds gnutls_alert_set_read_function(), to allow QUIC
    implementations to be notified when an alert message is sent.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Feb 21 17:48:37 2020 +0100

    handshake: add callback to get notified with traffic secret change
    
    For the use with QUIC, the change of traffic secrets must be notified
    _after_ a new epoch is set up for reading or writing, and we can't
    simply reuse the keylog mechanism.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Feb 19 14:35:04 2020 +0100

    handshake: add functions to read/write handshake messages directly
    
    This adds a couple of functions, gnutls_handshake_set_read_function()
    and gnutls_handshake_write(), to allow QUIC implementations to
    directly interact with the TLS state machine.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Nov 11 19:15:13 2020 +0100

    x509: rework issuer callback
    
    The previous issuer callback API had a drawback: the callback is
    supposed to add CA to the trust list by itself.  This was error-prone,
    because the callback must check the new CA is trusted by the already
    added CA.  This instead moves the responsibility to the library.
    
    This also rewrites the chain amendment logic in a side-effect free
    manner.  The application can assume that the trust information stored
    on gnutls_x509_trust_list_t shouldn't change after the verification.
    
    The missingissuer test has been extended to cover all the possible
    patterns exhaustively.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Nov 12 10:57:21 2020 +0100

    _gnutls_cert_log: assume that 'cert' is nonnull
    
    This makes static analyzers happy.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Nov 15 09:57:37 2020 +0100

    _gnutls_sort_clist: simplify the calling convention
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Tomas Mraz <tmraz@fedoraproject.org>
Date:   Mon Oct 26 15:23:24 2020 +0100

    Use proper record version in client hello after hello retry request
    
    Signed-off-by: Tomas Mraz <tmraz@fedoraproject.org>
    
    Fixes: #1053

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Nov 12 07:46:19 2020 +0100

    pkcs11: increase the maximum PIN length from 31 to 255
    
    The maximum is chosen from the default configuration of SoftHSMv2:
      https://github.com/opendnssec/SoftHSMv2/blob/develop/CMakeLists.txt#L61
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Thu Nov 12 08:45:03 2020 +0100

    _gnutls_x509_read_value: don't count terminating null byte for OIDs
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>
    Co-authored-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Nov 12 09:19:30 2020 +0100

    x509: clarify how to release memory allocated for DN
    
    The application can assume that DNs returned from
    _gnutls_x509_get_dn() are allocated with gnutls_malloc() and thus
    shall be freed with gnutls_free().
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Michael Catanzaro <mcatanzaro@gnome.org>
Date:   Mon Oct 12 16:33:54 2020 -0500

    pkcs11: fix session leak in error path
    
    gnutls_pkcs11_obj_set_info() fails to call pkcs11_close_session() after
    a successful pkcs11_open_session() if called with an invalid itype
    parameter. That would be programmer error, of course, but better not
    forget to close the session regardless.
    
    Signed-off-by: Michael Catanzaro <mcatanzaro@gnome.org>

Author: Sahana Prasad <sahana@redhat.com>
Date:   Mon Sep 28 10:21:40 2020 +0200

    Adds a new API gnutls_session_set_verify_output_function() that allows TLS applications
    to have a way to pass the gnutls_verify_output_function() as a callback so that the full
    path of the certificate chain to the trusted root can be avaiable as output.
    
    Signed-off-by: Sahana Prasad <sahana@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Nov 5 05:57:01 2020 +0100

    .gitlab-ci.yml: temporarily allow failures on Debian.cross.aarch64
    
    qemu is currently causing segmentation fault:
      cipher: aes-128-gcm
      cipher: aes-192-gcm
      cipher: aes-256-gcm
      cipher: chacha20-poly1305
      qemu: uncaught target signal 11 (Segmentation fault) - core dumped
      Segmentation fault (core dumped)
      default cipher tests failed
      FAIL test-ciphers-openssl.sh (exit status: 139)
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Nov 5 05:56:31 2020 +0100

    .gitlab-ci.yml: use nettle git master for FreeBSD.x86_64
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Nov 6 09:54:54 2020 +0100

    tls-sig: defer allowed sigalg check to gnutls_pubkey_verify_data2
    
    This reverts 485f2551e68d1b4ee70be2960f0a241b4a2b9fb9.  After the new
    configuration file has been introduced, the allowed algorithms are
    checked after this part.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Remi Olivier <remi_8@hotmail.com>
Date:   Wed Oct 28 20:43:25 2020 -0700

    Fix memory leak with client certificate auth
    Fix memory leak with client certificate auth when rehandshake with ocsp
    
    More info in bug: gnutls/gnutls#1107
    
    Signed-off-by: Remi Olivier <remi_8@hotmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Nov 5 05:51:56 2020 +0100

    Revert ".lgtm.yml: no longer bring nettle from master"
    
    This reverts commit bbe93dc315009fe1f9a30426cbe20f4661b8435c.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Nov 4 19:05:58 2020 +0100

    gostdsa: fix memleak in _gnutls_gostdsa_unmask_key
    
    Spotted by valgrind:
      ==5721== 40 bytes in 1 blocks are definitely lost in loss record 1 of 3
      ==5721==    at 0x4839809: malloc (vg_replace_malloc.c:307)
      ==5721==    by 0x4DC3E59: __gmp_default_allocate (in /usr/lib64/libgmp.so.10.4.0)
      ==5721==    by 0x4DD26A3: __gmpz_realloc (in /usr/lib64/libgmp.so.10.4.0)
      ==5721==    by 0x4DD8B9D: __gmpz_set_str (in /usr/lib64/libgmp.so.10.4.0)
      ==5721==    by 0x499339D: _gnutls_gostdsa_unmask_key (gostdsa-mask.c:68)
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Nov 4 18:58:25 2020 +0100

    testcompat-openssl: use RC4-SHA instead of RC4-MD5 for testing
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Nov 4 11:43:35 2020 +0100

    .gitlab-ci.yml: use Fedora 33 with LEGACY policy for SSL 3.0 testing
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Nov 4 09:46:10 2020 +0100

    .gitlab-ci.yml: supply -fstack-protector required by latest MinGW
    
    https://sourceforge.net/p/mingw-w64/bugs/818/
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Nov 4 08:56:04 2020 +0100

    tls-fuzzer: update submodules
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 12 17:42:15 2020 +0200

    .gitlab-ci.yml: avoid using fipshmac
    
    The new fipshmac command provided by libkcapi requires NETLINK_CRYPTO,
    which is not enabled on gitlab CI.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Oct 4 14:08:37 2020 +0200

    src: remove use of siginterrupt
    
    GCC 10 warns this:
      tests.c:702:2: error: 'siginterrupt' is deprecated: Use sigaction with SA_RESTART instead [-Werror=deprecated-declarations]
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Oct 3 16:15:25 2020 +0200

    .gitlab-ci.yml: update build-images for nettle 3.6
    
    Also remove Debian.cross.mips-linux-gnu, as it is no longer supported.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 6 08:56:07 2020 +0200

    build: hard require nettle 3.6
    
    This allows us to remove several backports, including XTS, CFB8,
    raw-ChaCha, CMAC64, Curve448, and the GOST curves and hashes.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Hans Leidekker <hans@codeweavers.com>
Date:   Tue Nov 3 12:31:38 2020 +0100

    Make y parameter optional in gnutls_privkey_import_dsa_raw().
    
    Signed-off-by: Hans Leidekker <hans@codeweavers.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Oct 30 16:53:47 2020 +0100

    psktool: Fix hex-encoding logic of username
    
    The previous code didn't modify the pointer to the realloc'ed region
    nor check overflow before calling realloc.
    
    Spotted by Anderson Sasaki in:
    <https://gitlab.com/gnutls/gnutls/-/merge_requests/1345#note_439063374>.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Sahana Prasad <sahana@redhat.com>
Date:   Thu Oct 29 10:18:56 2020 +0100

    PKCS#12: switch default encryption to AES-256-CBC
    
    Signed-off-by: Sahana Prasad <sahana@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 26 16:32:59 2020 +0100

    srptool: fix FILE pointer leak
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Oct 25 08:36:57 2020 +0100

    mini-record-timing: use only async-signal-safe functions in handler
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Oct 24 10:23:03 2020 +0200

    psktool: encode username if it contains special character
    
    This also moves the hex encoding of key to write_key for readability
    and makes file stream closing robuster.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 26 15:42:22 2020 +0100

    bootstrap.conf: exercise more tests from Gnulib
    
    This fixes the build failure with -Werror:
    
      configure:53786: gcc -o conftest -O0 -Wall -Werror -g3   conftest.c  -lev >&5
      conftest.c:412: error: "GNULIB_STRERROR" redefined [-Werror]
        412 | #define GNULIB_STRERROR 1
            |
      conftest.c:305: note: this is the location of the previous definition
        305 | #define GNULIB_STRERROR IN_GNUTLS_GNULIB_TESTS
            |
      cc1: all warnings being treated as errors
    
    as well as improves code coverage.
    
    Suggested by Bruno Haible in:
    <https://lists.gnu.org/archive/html/bug-gnulib/2020-10/msg00148.html>.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Oct 24 09:48:07 2020 +0200

    gnutls_psk_set_server_credentials_file: document the file format
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Oct 18 17:58:49 2020 +0200

    serv: use only async-signal-safe functions in signal handlers
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Oct 18 09:50:46 2020 +0200

    _gnutls_asn2err: define as static inline
    
    This pacifies -fanalyzer false-positive:
      common.c:552:3: warning: use of NULL '<unknown>' where non-null expected [CWE-690] [-Wanalyzer-null-argument]
    
    Ideally, the function should be defined as 'extern inline' to avoid
    code bloat by being copied across multiple translation units.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Oct 18 07:19:29 2020 +0200

    doc/examples/ex-ocsp-client.c: check malloc return value
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Oct 18 07:25:42 2020 +0200

    serv: peer_print_info: add overflow check on realloc
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Oct 18 07:17:38 2020 +0200

    serv: replace our own list implementation with Gnulib's gl_list
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 5 17:59:46 2020 +0200

    fips: run CMAC self-tests
    
    FIPS140-2 IG D.8 mandates self-tests on CMAC.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 5 17:44:30 2020 +0200

    fips: add self-tests for TLS-PRF
    
    FIPS140-2 IG D.8 mandates self-tests on approved KDF algorithms.  As
    the guidance only requires to run a single instance of each KDF
    mechanism, this only exercises TLS1.2 PRF with HMAC-SHA-256 as the
    underlying MAC algorithm.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Oct 6 11:54:21 2020 +0200

    fips: use larger prime for DH self-tests
    
    According to FIPS140-2 IG 7.5, the minimum key size of FFC through
    2030 is defined as 2048 bits.  This updates the relevant self-test
    using ffdhe3072 defined in RFC 7919.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 5 16:59:50 2020 +0200

    fips: add self-tests for PBKDF2
    
    FIPS140-2 IG D.8 mandates self-tests on approved KDF algorithms.  As
    the guidance only requires running a single instance of each KDF
    mechanism, this only exercises PBKDF2 with HMAC-SHA-256 as the
    underlying MAC algorithm.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Oct 5 16:12:46 2020 +0200

    fips: add self-tests for HKDF
    
    FIPS140-2 IG D.8 mandates self-test on approved KDF algorithms.  As
    the guidance only requires running a single instance of each KDF
    mechanism, this only exercises HKDF-Extract and HKDF-Expand operations
    with HMAC-SHA-256 as the underlying MAC.
    
    Although HKDF is non-approved, it would be sensible to do that as it
    will be approved in FIPS140-3.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Oct 3 14:50:26 2020 +0200

    tests: add missing ${EXEEXT}
    
    Pointed by Andreas Metzler.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Oct 2 17:23:27 2020 +0200

    tests: prolong timeout in wait_for_port
    
    gnutls-serv invocations in cert-tests/dsa can take long time to launch
    if valgrind tests are enabled.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Sep 28 19:05:52 2020 +0200

    tests: remove unused lock facility using lockfile-create
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Sep 26 11:58:17 2020 +0200

    tests: create lock for tests using GETPORT
    
    This fixes a race condition in the timings between when a free port is
    detected and when the port is actually used.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Sep 24 11:48:24 2020 +0200

    tests: simplify program detection
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Sep 24 10:47:30 2020 +0200

    tests: rewrite launch_server using launch_bare_server
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 27 16:11:32 2020 +0200

    x509: correct argument of gnutls_verify_output_function
    
    This is a leftover of 52e78f1e.  We need to call
    gnutls_verify_output_function with the replaced CA cert instead of the
    original cert.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Sep 23 09:34:09 2020 +0200

    tests: remove launch_pkcs11_server
    
    This function is only used by testpkcs11.sh.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Sep 23 09:12:32 2020 +0200

    tests: remove unused first argument from launch_server
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Sep 23 09:09:45 2020 +0200

    tests: use ": ${FOO=BAR}" syntax for default handling in shell scripts
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: JonasZhou <JonasZhou@zhaoxin.com>
Date:   Wed Sep 23 19:22:50 2020 +0800

    x86:Modify variable name
    
    Modify the variables _gnutls_sha_padlock and _gnutls_sha_padlock_nano.
    Add a comment for detecting CPU. Modify the indentation. Delete
    initialization etc.
    
    Signed-off-by: JonasZhou <JonasZhou@zhaoxin.com>

Author: JonasZhou <JonasZhou@zhaoxin.com>
Date:   Tue Sep 15 16:36:57 2020 +0800

    x86:add detection of instruction set on Zhaoxin CPU
    
    Add detection of extended instruction set on Zhaoxin cpu,e.g:ssse3,sha,
    etc. Set the priority of the algorithm according to the benchmark
    test result on Zhaoxin cpu.
    
    Signed-off-by: JonasZhou <JonasZhou@zhaoxin.com>

Author: JonasZhou <JonasZhou@zhaoxin.com>
Date:   Wed Sep 16 14:08:21 2020 +0800

    x86: fix avx detection
    
    In the case of setting environment variables, AVX cannot be detected
    correctly. Because only MOVBE is added to variable _gnutls_x86_cpuid_s,
    there is no OSXSAVE. And according to the intel manual, using AVX
    does not need to detect FMA.
    
    Signed-off-by: JonasZhou <JonasZhou@zhaoxin.com>

Author: JonasZhou <JonasZhou@zhaoxin.com>
Date:   Wed Sep 23 14:19:39 2020 +0800

    padlock:fix exception in wrap_padlock_hmac_fast
    
    In function wrap_padlock_hmac_fast, use free to release local variables
    ctx. Remove a call to wrap_padlock_hmac_deinit() to fix a crash.
    
    Signed-off-by: JonasZhou <JonasZhou@zhaoxin.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Sep 14 17:59:00 2020 +0200

    testcompat-openssl: specify -sigalgs
    
    The default selection of signature schemes is also affected by the
    crypto-policies, and needs to be explicitly enabled with -sigalgs.
    
    Suggested by Tomas Mraz.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Sep 14 08:31:17 2020 +0200

    inih: remove unused code
    
    This avoids -fanalyzer false-positive in GCC 10:
    https://bugzilla.redhat.com/show_bug.cgi?id=1878600
    as well as the cppcheck warning:
    "variableScope:lib/inih/ini.c:99,style,The scope of the variable 'start' can be reduced."
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 20 17:49:17 2020 +0200

    priority: add Ed448 to SECURE192 signing algorithms
    
    Reported Vladimír Čunát in:
    https://gitlab.com/gnutls/gnutls/-/merge_requests/984#note_349374656
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Sat Sep 19 10:57:04 2020 +0200

    testsuite: Fix $SERV / $GNUTLS_SERV inconsistency
    
    Some tests did not support overriding the PATH to gnutls-serv by setting
    the environment variable SERV but used GNUTLS_SERV instead.
    
    Closes #1090
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Fri Sep 18 13:55:06 2020 +0200

    In testsuite scripts use "$@" instead of $*.
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 13 17:19:32 2020 +0200

    build: remove dead assignments
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Sep 8 19:55:14 2020 +0200

    spki: work around GCC 10 -Warray-bounds false-positive
    
    Suggested by Martin Sebor in:
    https://bugzilla.redhat.com/show_bug.cgi?id=1876801#c1
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Sep 8 19:51:07 2020 +0200

    tls13/session_ticket: remove _gnutls13_session_ticket_unset
    
    The function was not really useful because _gnutls_free_datum()
    has a NULL check as in free().  This also makes GCC 10 happy if
    -Warray-bounds=2 is specified:
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96984
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Sep 7 09:52:52 2020 +0200

    tests: allow clock_nanosleep in seccomp tests
    
    The nanosleep wrapper in glibc has changed the implementation using
    the clock_nanosleep syscall:
    https://sourceware.org/git/?p=glibc.git;a=commit;h=3537ecb49cf7177274607004c562d6f9ecc99474
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Sep 7 09:52:09 2020 +0200

    .gitlab-ci.yml: bump build environment to Fedora 32
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Wed Sep 16 07:18:51 2020 +0200

    testsuite: Run GOST part of tests/gnutls-cli-debug.sh
    
    Closes #1097
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Andreas Metzler <ametzler@debian.org>
Date:   Wed Sep 16 07:13:06 2020 +0200

    testsuite: Fix GOST gnutls-cli-debug test
    
    GOST algorithms are not enabled by default, explicitely request them in
    priority string.
    
    Signed-off-by: Andreas Metzler <ametzler@bebt.de>

Author: Sahana Prasad <sahana@redhat.com>
Date:   Mon Sep 14 13:09:00 2020 +0200

    Modifies P_hash() to hash the seed and label separately
    Thereby not restricting the implementation of prf to MAX_SEED_SIZE
    MAX_SEED_SIZE is not used anymore
    
    Signed-off-by: Sahana Prasad <sahana@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Sep 17 12:03:20 2020 +0200

    build: ignore pointless -Wformat-nonliteral warning
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Sep 17 11:15:43 2020 +0200

    configure.ac: don't enable warning only available in decent gcc
    
    -Warith-conversion is new in GCC 10.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Sep 12 20:29:54 2020 +0200

    .gitlab-ci.yml: bump cache version
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 13 20:27:05 2020 +0200

    build: ignore pointless -Wformat-y2k warning
    
    Printing UTCTime really needs last 2 digits of the year.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Sep 13 17:52:44 2020 +0200

    gnulib: update git submodule
    
    This brings in the build fixes of parse-datetime module:
    https://lists.gnu.org/archive/html/bug-gnulib/2020-07/msg00178.html
    https://lists.gnu.org/archive/html/bug-gnulib/2020-08/msg00001.html
    https://lists.gnu.org/archive/html/bug-gnulib/2020-09/msg00046.html
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Nikolay Sivov <nsivov@codeweavers.com>
Date:   Sun Sep 6 23:42:33 2020 +0300

    Make private exponent optional in gnutls_privkey_import_rsa_raw().
    
    Signed-off-by: Nikolay Sivov <nsivov@codeweavers.com>

Author: Nikolay Sivov <nsivov@codeweavers.com>
Date:   Sun Sep 6 21:18:57 2020 +0300

    Use symbols defined for RSA key parameter indices in some more places.
    
    Signed-off-by: Nikolay Sivov <nsivov@codeweavers.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Aug 22 17:19:39 2020 +0200

    handshake: reject no_renegotiation alert if handshake is incomplete
    
    If the initial handshake is incomplete and the server sends a
    no_renegotiation alert, the client should treat it as a fatal error
    even if its level is warning.  Otherwise the same handshake
    state (e.g., DHE parameters) are reused in the next gnutls_handshake
    call, if it is called in the loop idiom:
    
      do {
              ret = gnutls_handshake(session);
      } while (ret < 0 && gnutls_error_is_fatal(ret) == 0);
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Nikolay Sivov <nsivov@codeweavers.com>
Date:   Wed Sep 2 23:49:14 2020 +0300

    Consolidate optional arguments tests for RSA key import, cleanup after each import.
    
    Signed-off-by: Nikolay Sivov <nsivov@codeweavers.com>

Author: Nikolay Sivov <nsivov@codeweavers.com>
Date:   Wed Sep 2 23:14:14 2020 +0300

    Move RSA key parameter counter fixup closer to exponent update helper.
    
    Signed-off-by: Nikolay Sivov <nsivov@codeweavers.com>

Author: Sahana Prasad <sahana@redhat.com>
Date:   Tue Sep 1 23:16:53 2020 +0200

    src/cli: adds new option '--ca-auto-retrieve' that can be used with gnutls-cli to
             automatically download missing intermediate CAs in a certificate chain
    lib/cred-cert.c : adds set and get APIs to get user data in the
            gnutls_x509_trust_list_set_getissuer_function() callback.
    
    Signed-off-by: Sahana Prasad <sahana@redhat.com>

Author: Nikolay Sivov <nsivov@codeweavers.com>
Date:   Tue Sep 1 21:00:18 2020 +0300

    Add some tests for optional arguments in gnutls_privkey_import_rsa_raw().
    
    Signed-off-by: Nikolay Sivov <nsivov@codeweavers.com>

Author: Nikolay Sivov <nsivov@codeweavers.com>
Date:   Tue Sep 1 19:29:20 2020 +0300

    Fix optional parameters counter when importing RSA private keys.
    
    Currently gnutls_privkey_import_rsa_raw() allows 3 last arguments to be omitted,
    key fixup logic however checks for 3 missing arguments when updating coefficient 'u'
    but then asserts when updating exponents 'e1' and 'e2' assuming only 2 parameters
    are missing at that point.
    
    Signed-off-by: Nikolay Sivov <nsivov@codeweavers.com>

Author: Nikolay Sivov <nsivov@codeweavers.com>
Date:   Tue Sep 1 19:15:02 2020 +0300

    Use symbols defined for RSA key parameter indices in more places.
    
    Signed-off-by: Nikolay Sivov <nsivov@codeweavers.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Aug 30 14:40:13 2020 +0200

    tests: fix sizeof usage in mini-record-timing
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Aug 30 14:35:47 2020 +0200

    padlock: fix partial PHE detection
    
    The xsha1 instruction takes complete SHA-1 blocks (64 bytes) instead
    of arbitrary length data when EAX is set to -1.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Albrecht Dreß <albrecht.dress@arcor.de>
Date:   Sat Aug 29 14:33:05 2020 +0200

    improve gnutls-serv EOL processing
    
    add option `--crlf` to gnutls-serv to disable replacing a received CRLF
    by LF in echo mode (fixes #1073).
    
    Signed-off-by: Albrecht Dreß <albrecht.dress@arcor.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Aug 13 18:17:08 2020 +0200

    gnutls_aead_cipher_decrypt: check output buffer size before writing
    
    While the documentation of gnutls_aead_cipher_decrypt indicates that
    the inout argument ptext_len initially holds the size that
    sufficiently fits the expected output size, there was no runtime check
    on that.  This makes the interface robuster against misuses.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Aug 16 11:43:35 2020 +0200

    handshake: check TLS version against modified server priorities
    
    The server needs to take into account of multiple factors when
    determining the TLS protocol version actually being used:
    - the legacy version
    - "supported_versions" extension
    - user_hello_func that may modify the server's priorities
    
    Only after that it can check whether the TLS version is enabled in the
    server's priorities.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Aug 16 18:23:24 2020 +0200

    gnutls_x509_crt_export2: return 0 instead of the length
    
    This aligns the behavior to the documentation.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Sun Aug 16 14:05:44 2020 +0200

    Fix parser output in tests/cert-tests/data/gost-cert-nogost.pem
    
    When building without GOST support parsing a GOST certificate must
    return an "error importing public key" message instead of key
    details. This change makes tests/cert-tests/pem-decoding pass for
    builds with --disable-gost.
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Aug 14 07:27:40 2020 +0200

    cert-session: check OCSP error responses
    
    If the OCSP responder returns an error code, such as tryLater, we
    can't proceed to examine the response bytes.  In that case, just skip
    the check unless the stapling is mandatory on this certificate.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Wed Jul 15 09:34:19 2020 +0200

    mangle gnutls-built ecc_scalar_random
    
    GNUTLS builds ecc-random.c but ecc_scalar_random() is a public API. So we
    mangle the internal version we build.
    
    ecc_mod_random is unaffected as it's an internal API that is mangled by GNUTLS.
    
    Fixes #1016
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Aug 13 15:56:20 2020 +0200

    minitasn1: move WARN_CFLAGS setting to configure.ac
    
    Some compilers don't support -Wno-type-limits, while they support
    -Wtype-limits.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Jun 4 16:42:07 2020 +0200

    _gnutls_fips_mode_enabled: treat selftest failure as FIPS disabled
    
    Previously gnutls_fips140_mode_enabled() returned true, even after
    selftests have failed and the library state has switched to error.
    While later calls to crypto operations fails, it would be more
    convenient to have a function to detect that state.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Aug 12 08:10:51 2020 +0200

    doc: assorted typo fixes
    
    Spotted by codespell.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Aug 12 07:29:30 2020 +0200

    serv, cli: ensure that invalid flag is always set
    
    According to the documentation, the GNUTLS_CERT_INVALID flag must
    always be set in case of verification failure, together with the flag
    indicating the actual error cause.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Wed Aug 12 07:27:17 2020 +0200

    cert-session: fail hard if mandatory stapling is not honored
    
    According to the documentation, the GNUTLS_CERT_INVALID flag must
    always be set in case of verification failure, together with the flag
    indicating the actual error cause.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Michael Catanzaro <mcatanzaro@gnome.org>
Date:   Fri Aug 7 13:55:23 2020 -0500

    Fix invalid free in missing issuer test case error path
    
    This variable is not initialized in this error path: it's only
    initialized if gnutls_x509_crt_get_authority_info_access() succeeds.
    
    Signed-off-by: Michael Catanzaro <mcatanzaro@gnome.org>

Author: Michael Catanzaro <mcatanzaro@gnome.org>
Date:   Fri Aug 7 13:00:22 2020 -0500

    Fix typo in API docs
    
    Signed-off-by: Michael Catanzaro <mcatanzaro@gnome.org>

Author: Petr Pavlu <petr.pavlu@suse.com>
Date:   Wed Jul 8 10:12:30 2020 +0200

    pubkey: avoid spurious audit messages from _gnutls_pubkey_compatible_with_sig()
    
    When checking in _gnutls_pubkey_compatible_with_sig() whether a public
    key is compatible with a signature algorithm, run first
    pubkey_supports_sig() before performing weaker checks that can accept
    the given algorithm but with an audit-log warning. This avoids an issue
    when a weaker check would log an audit message for some signature
    algorithm that would then be determined as incompatible by the
    pubkey_supports_sig() check anyway.
    
    For instance, a GnuTLS server might have a certificate with a SECP384R1
    public key and a client can report that it supports
    ECDSA-SECP256R1-SHA256 and ECDSA-SECP384R1-SHA384. In such a case, the
    GnuTLS server will eventually find that it must use
    ECDSA-SECP384R1-SHA384 with this public key. However, the code would
    first run _gnutls_pubkey_compatible_with_sig() to check if SECP384R1 is
    compatible with ECDSA-SECP256R1-SHA256. The function would report the
    audit warning "The hash size used in signature (32) is less than the
    expected (48)" but then reject the signature algorithm in
    pubkey_supports_sig() as incompatible because it has a different curve.
    Since the algorithm gets rejected it is not necessary to inform about
    its hash size difference in the audit log.
    
    Signed-off-by: Petr Pavlu <petr.pavlu@suse.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Jul 18 08:26:48 2020 +0200

    ecdh: perform SP800-56A rev3 full pubkey validation on keygen
    
    This implements full public key validation required in
    SP800-56A rev3, section 5.6.2.3.3.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jul 17 17:47:06 2020 +0200

    dh: perform SP800-56A rev3 full pubkey validation on keygen
    
    This implements full public key validation required in SP800-56A rev3,
    section 5.6.2.3.1.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jul 17 17:45:17 2020 +0200

    dh-primes: make the FIPS approved check return Q value
    
    This is necessary for full public key validation in
    SP800-56A (revision 3), section 5.6.2.3.1.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jul 10 09:42:30 2020 +0200

    ecdh: check validity of P before export
    
    SP800-56A rev3 section 5.7.1.2 step 2 mandates that the validity of
    the calculated shared secret is verified before the data is returned
    to the caller.  This patch adds the validation check.
    
    Suggested by Stephan Mueller.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jul 10 09:35:49 2020 +0200

    dh: check validity of Z before export
    
    SP800-56A rev3 section 5.7.1.1 step 2 mandates that the validity of the
    calculated shared secret is verified before the data is returned to the
    caller.  This patch adds the validation check.
    
    Suggested by Stephan Mueller.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   Fri Jul 3 14:54:17 2020 +0200

    tests: split up system-override-sig-hash.sh
    
    Split up system-override-sig-hash.sh
    so that the errors won't get swallowed or conflated.
    Also correct unused `srcdir` to `builddir`,
    which I believe was meant to be set there.
    
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Mon Jun 22 09:09:05 2020 +0200

    fix connectx not available on older macOS SDK
    
    Fixes this compilation error:
    system/fastopen.c:134:9: error: 'connectx' is only available on macOS 10.11 or newer [-Werror,-Wunguarded-availability]
                    ret = connectx(fd, &endpoints, SAE_ASSOCID_ANY, CONNECT_RESUME_ON_READ_WRITE | CONNECT_DATA_IDEMPOTENT, NULL, 0, NULL, NULL);
                          ^~~~~~~~
    /Applications/Xcode9.2.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.13.sdk/usr/include/sys/socket.h:713:5: note: 'connectx' has been marked as being introduced in macOS 10.11 here, but the deployment target is macOS 10.7.0
    
    The detection is the same as found in curl [1].
    
    If HAVE_BUILTIN_AVAILABLE is not available we fallback to the code without
    TCP_FASTOPEN_OSX.
    
    The OS values match exactly the values found in
    https://opensource.apple.com/source/xnu/xnu-4570.41.2/bsd/sys/socket.h
    
    [1] https://github.com/curl/curl/commit/870d849d48a26b8eeb0d4bb1f4655367a4a191ca
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: James Bottomley <James.Bottomley@HansenPartnership.com>
Date:   Sun Jun 28 21:33:09 2020 +0200

    build: use $(LIBPTHREAD) rather than non-existent $(LTLIBPTHREAD)
    
    On a very recent openSUSE build, libgnutls is getting built without
    libpthread. This caused a thread related error when trying to load a
    pkcs11 module that uses threading. The reason is rather convoluted:
    glibc actually controls all the pthread_ function calls, but it
    returns success without doing anything unless -lpthread is in the link
    list. What's happening is that gnutls_system_mutex_init() is being
    called on _gnutls_pkcs11_mutex before library pthreading is
    initialized, so the pthread_mutex_init ends up being a nop. Then, when
    the pkcs11 module is loaded, pthreads get initialized and the call to
    pthread_mutex_lock is real, but errors out on the uninitialized mutex.
    
    The problem seems to be that nothing in the gnulib macros gnutls
    relies on for threading support detection actually sets LTLIBPTHREAD,
    they only set LIBPTHREAD. The fix is to use LIBPTHREAD in
    lib/Makefile.in
    
    Signed-off-by: James Bottomley <James.Bottomley@HansenPartnership.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jun 21 16:03:54 2020 +0200

    safe_memcmp: remove in favor of gnutls_memcmp
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 26 10:21:26 2020 +0200

    dhe: check if DH params in SKE match the FIPS approved algorithms
    
    SP800-56A rev. 3 restricts the FIPS compliant clients to use only
    approved DH parameters, defined in RFC 7919 and RFC 3526.  This adds a
    check in the handling of ServerKeyExchange if DHE is negotiated.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 26 09:43:02 2020 +0200

    dh-primes: add MODP primes from RFC 3526
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Tue Jun 16 21:23:14 2020 +0200

    Update tlsfuzzer to get Python interpreter detection
    
    Tlsfuzzer also assumed the Python interpreter would be called
    "python", this update is necessary to get a fixed version (see
    https://github.com/tomato42/tlsfuzzer/pull/671).
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Tue Jun 16 20:48:44 2020 +0200

    Detect Python interpreter instead of assuming "python"
    
    This makes the extended test suite work one Debian(-ish) systems
    without Python 2, where the Python 3 interpreter is called "python3".
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 12 16:50:14 2020 +0200

    .gitlab-ci.yml: bump configure cache version
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 12 11:34:38 2020 +0200

    .gitignore: ignore more files
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 12 11:32:58 2020 +0200

    build: avoid -Wenum-conversion warnings with GCC 10
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Sun Jun 14 23:31:27 2020 +0300

    .gitlab-ci: disable config.cache for nettle-master builds
    
    Disable usage of config.cache for nettle-master builds. Such
    config.cache files can easily become stale, thus resulting in build
    failures.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Fiona Klute <fiona.klute@gmx.de>
Date:   Sun Jun 14 12:52:46 2020 +0200

    Wipe session ticket keys before releasing the session structure
    
    This includes both a copy of the master key and one or two derived
    keys, all of which could be used to decrypt session tickets if
    stolen. The derived keys could only be used for tickets issued within
    a certain time frame (by default several hours).
    
    The documentation for gnutls_session_ticket_enable_server() already
    states that the master key should be wiped before releasing it, and
    the same should apply to internal copies.
    
    Signed-off-by: Fiona Klute <fiona.klute@gmx.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 9 10:44:57 2020 +0200

    tests/cert-test/invalid-sig: use datefudge to test expired certs
    
    Suggested by Andreas Metzler in:
    https://gitlab.com/gnutls/gnutls/-/issues/1021
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 9 10:41:18 2020 +0200

    tests: check_for_datefudge: don't exit the test programs
    
    This makes check_for_datefudge not to immediately exit the program,
    but to return non-zero to allow the tests by themselves to control the
    behavior when "datefudge" is not found.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Vitezslav Cizek <vcizek@suse.com>
Date:   Tue Jun 9 13:54:04 2020 +0200

    configure: improve nettle, gmp, and hogweed soname detection
    
    Some linkers might optimize away the libraries passed on the
    command line if they aren't actually needed, such as gnu ld with
    --as-needed.
    The ldd output then won't list the shared libraries and the
    detection will fail.
    Make sure nettle and others are really used.
    
    Signed-off-by: Vitezslav Cizek <vcizek@suse.com>

Author: Lei Maohui <leimaohui@cn.fujitsu.com>
Date:   Mon Jun 8 16:15:07 2020 +0900

    Modied the license to GPLv2.1+ to keep with LICENSE file.
    
    Signed-off-by: Lei Maohui <leimaohui@cn.fujitsu.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jun 8 06:45:24 2020 +0200

    configure.ac: prefer the latest version of build infrastructure
    
    AM_GNU_GETTEXT_REQUIRE_VERSION tells autopoint to copy the latest
    possible build infrastructure installed on the system, rather than the
    fixed version from the archive.dir.tar.xz.  This makes the
    bootstrapping slightly faster and allows us not to stick with the
    ancient gettext version.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Sun Jun 7 17:41:21 2020 +0000

    CI: fix typo in the Vista target
    
    This resulted in the MinGW64.Vista+ target doing the same thing as the MinGW64
    target.
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jun 7 15:46:51 2020 +0200

    RELEASES.md: move the release steps to devel/ [ci skip]
    
    As the information is only useful to developers, having it under
    devel/ rather than in the tarball is more releavant.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jun 7 15:45:13 2020 +0200

    RELEASES.md: mention 3.7.x releases
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jun 7 15:41:59 2020 +0200

    RELEASES.md: fix typo in scp command line
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Jun 7 15:39:39 2020 +0200

    NEWS: add missing API modifications to 3.6.14 entry
    
    Reported by Andreas Metzler in:
    https://lists.gnupg.org/pipermail/gnutls-help/2020-June/004650.html
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu Jan 9 01:42:22 2020 +0300

    crypto-selftest: add test vectors for MAGMA/KUZNYECHIK-CTR-ACPKM
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu Jan 9 01:11:50 2020 +0300

    crypto-api: add _gnutls_cipher_set_key wrapper()
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu Oct 17 16:38:40 2019 +0300

    cipher/mac: enhance handlers with setkey callback
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu Jan 9 00:58:50 2020 +0300

    selftests: add test vectors for MAGMA/KUZNYECHIK-OMAC
    
    Add test vectors for newly added MAC algorithms.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Fri Sep 21 22:11:51 2018 +0300

    lib: add Magma/Kuznyechik OMAC support
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Fri Sep 21 22:11:14 2018 +0300

    lib: add Magma/Kuznyechik ciphers support
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Fri Sep 21 22:10:30 2018 +0300

    nettle/gost: add ACPKM rekeying code
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Fri Sep 21 22:10:03 2018 +0300

    nettle/gost: add CMAC-64/Magma/Kuznyechik code
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Fri Sep 21 22:09:36 2018 +0300

    nettle/gost: add Kuznyechik code
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Fri Sep 21 22:09:11 2018 +0300

    nettle/gost: add Magma code
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Fri Sep 21 22:08:44 2018 +0300

    nettle/gost: export gost28147_decrypt_simple for magma cipher
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Sat Jun 6 14:05:16 2020 +0200

    Merge the extra libraries to link dynamically in GNUTLS_LIBS_PRIVATE
    
    This should fix #1020 where bcrypt is missing from thirdparty_libadd.
    
    Ultimately it would be good to add libraries that always need to be linked in
    one variable that is shared between the Makefile and the pkg-config file.
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Jun 5 16:26:33 2020 +0200

    crypto-api: always allocate memory when serializing iovec_t
    
    The AEAD iov interface falls back to serializing the input buffers if
    the low-level cipher doesn't support scatter/gather encryption.
    However, there was a bug in the functions used for the serialization,
    which causes memory leaks under a certain condition (i.e. the number
    of input buffers is 1).
    
    This patch makes the logic of the functions simpler, by removing a
    micro-optimization that tries to minimize the number of calls to
    malloc/free.
    
    The original problem was reported by Marius Steffen in:
    https://bugzilla.samba.org/show_bug.cgi?id=14399
    and the cause was investigated by Alexander Haase in:
    https://gitlab.com/gnutls/gnutls/-/merge_requests/1277
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: František Krenželok <krenzelok.frantisek@gmail.com>
Date:   Thu Jun 4 16:59:33 2020 +0200

    tests: updated tlsfuzzer tests to latest version
    excluded some tests from test-certificate-malformed.py
    
    Signed-off-by: KrenzelokFrantisek <krenzelok.frantisek@gmail.com>

Author: Sahana Prasad <sahana@redhat.com>
Date:   Wed May 27 12:42:24 2020 +0200

    devel/libgnutls-latest-x86_64.abi, doc, NEWS, and manpage updates
    
    Signed-off-by: Sahana Prasad <sahana@redhat.com>

Author: Sahana Prasad <sahana@redhat.com>
Date:   Fri May 22 15:11:32 2020 +0200

    tests: Adds new tests missingissuer and missingissuer_aia
    
    Signed-off-by: Sahana Prasad <sahana@redhat.com>

Author: Sahana Prasad <sahana@redhat.com>
Date:   Fri May 22 09:42:47 2020 +0200

    Implements a callback function gnutls_x509_trust_list_set_getissuer_function()
    
    Signed-off-by: Sahana Prasad <sahana@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jun 1 14:18:03 2020 +0200

    Release 3.6.14 [ci skip]
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 2 21:45:17 2020 +0200

    valgrind: check if session ticket key is used without initialization
    
    This adds a valgrind client request for
    session->key.session_ticket_key to make sure that it is not used
    without initialization.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 2 20:53:11 2020 +0200

    stek: differentiate initial state from valid time window of TOTP
    
    There was a confusion in the TOTP implementation in stek.c.  When the
    mechanism is initialized at the first time, it records the timestamp
    but doesn't initialize the key.  This removes the timestamp recording
    at the initialization phase, so the key is properly set later.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 2 05:38:28 2020 +0200

    gnutls_cipher_init: fix potential memleak
    
    Upon failure this function returns without freeing memory allocated
    internally.  This makes sure that it is released and do not touch the
    output handle argument.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Jun 2 05:34:29 2020 +0200

    gnutls_aead_cipher_init: fix potential memleak
    
    When _gnutls_aead_cipher_init() fails, the function returns without
    freeing the allocted handle.  This was once fixed in commit
    502be130493e8ce802cdf60fffdbb5f1885352a5 but regressed after a code
    reorganization in commit 2eef509ce5f2d250f8dcaeffa46444dd2b694e91.
    
    Reported by Miroslav Lichvar.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Jun 1 17:23:59 2020 +0200

    serv: omit upper bound of --maxearlydata option definition
    
    It turned out that AutoGen treats numbers that exceed INT_MAX in a
    platform dependent way.  In this case, 4294967295 (UINT_MAX) is
    treated as is on 64-bit platforms, while it is interpreted as "-1" on
    32-bit platforms.  This causes a problem when the program
    documentation is compiled under multilib environment.
    
    Reported by Ivan Molodetskikh in:
    https://bugzilla.redhat.com/show_bug.cgi?id=1841844
    and the cause was identified by Anderson Toshiyuki Sasaki.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun May 31 14:28:48 2020 +0200

    tests: add test case for certificate chain superseding
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun May 31 13:59:53 2020 +0200

    x509: trigger fallback verification path when cert is expired
    
    gnutls_x509_trust_list_verify_crt2 use the macro SIGNER_OLD_OR_UNKNOWN
    to trigger the fallback verification path if the signer of the last
    certificate is not in the trust store.  Previously, it doesn't take
    into account of the condition where the certificate is expired.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun May 31 12:39:14 2020 +0200

    _gnutls_pkcs11_verify_crt_status: check validity against system cert
    
    To verify a certificate chain, this function replaces known
    certificates with the ones in the system trust store if possible.
    
    However, if it is found, the function checks the validity of the
    original certificate rather than the certificate found in the trust
    store.  That reveals a problem in a scenario that (1) a certificate is
    signed by multiple issuers and (2) one of the issuers' certificate has
    expired and included in the input chain.
    
    This patch makes it a little robuster by actually retrieving the
    certificate from the trust store and perform check against it.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 16 17:16:08 2020 +0100

    devel: provide external git diff driver for *.abi files [ci skip]
    
    This adds an external diff driver for *.abi files, that shows only
    interesting changes in those files.  This would be useful when adding
    a new API.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat May 30 11:06:57 2020 +0200

    build: write "FILE *fp" instead of "FILE *fd"
    
    This makes it clear that "fd" is not a file descriptor but a FILE
    pointer.  Suggested by Tim Rühsen.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 25 15:33:49 2020 +0200

    gnutls_load_file: document limitation regarding partial failure
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 25 11:21:38 2020 +0200

    cert-cred: clear private key data loaded from file
    
    This makes use of the RF_SENSITIVE flag newly added to read_file
    function when reading potentially senstive information from a file.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 25 10:09:28 2020 +0200

    lib: avoid file descriptor leak when application forks
    
    This makes use of the "e" flag of fopen, provided by the Gnulib's
    fopen-gnu module.
    
    Reported by Remi Denis-Courmont in:
    https://gitlab.com/gnutls/gnutls/-/issues/985
    and fix suggested by Tim Rühsen.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 25 18:37:51 2020 +0200

    gnulib: update git submodule
    
    This brings in the new fopen-gnu module and the RF_SENSITIVE flag for
    fread_file and read_file.  This also adds the following changes to be
    consistent with the latest changes in Gnulib:
    - the callers of fread_file and read_file to be adjusted for the FLAGS
      argument
    - "attribute.h" needs to be used extensively
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu May 28 00:05:35 2020 +0300

    p12: do not encrypt encrypt certificate bag with empty password
    
    Do not encrypt certificate bag if the user has specified empty password
    (--password ''). Encryption can be turned on by specifying
    --empty-password.
    
    Fixes #888
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Wed Apr 29 10:32:08 2020 +0200

    win32: use bcrypt instead of CryptoAPI on Vista+ for random numbers
    
    CryptoAPI is a deprecated API [1] that is forbidden in UWP builds.
    
    Rewrite the CryptoAPI calls in bcrypt.
    
    bcrypt is used instead of CryptoAPI when targeting Windows Vista and above.
    
    https://docs.microsoft.com/en-us/windows/win32/api/wincrypt/nf-wincrypt-cryptdecrypt
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Wed May 27 23:42:01 2020 +0300

    certtool: do not ask for private key password if it was provided
    
    Make pin_callback() use cinfo->password if it is set (via command line
    or from template).
    
    Fixes #933
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu May 28 03:15:55 2020 +0300

    .travis.yml: use several different OSX versions
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Wed May 27 21:14:50 2020 +0000

    win32: move the NCRYPT key import into a function
    
    No functional change. The has been simply moved.
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Wed May 27 21:13:43 2020 +0000

    configure.ac: determine if the Vista APIs can be linked statically
    
    If _WIN32_WINNT is higher or equal to 0x0600, Vista API's are allowed during
    the build. We can assume that the minimum platform the code will run on is
    Vista [1]
    
    In that case there's no need to call API's (ncrypt) dynamically when it can be
    done statically.
    
    [1] https://docs.microsoft.com/en-us/cpp/porting/modifying-winver-and-win32-winnt
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Wed May 27 00:34:02 2020 +0300

    lib: add support for AES-192-GCM
    
    Add support for AES-192 in GCM mode.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue May 26 16:19:59 2020 +0300

    configure: check that -no_weak_links works with FD_SET
    
    Several Xcode/SDK versions provide FD_SET implementation that does not
    work with -no_weak_links. Check that this option does not break FD_SET
    usage.
    
    Fixes #966
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue May 26 13:12:24 2020 +0300

    tests: build datefudge-check during make all
    
    Most of the tests depend on datefudge-check. Let's make it during 'make
    all' stage to allow running individual tests w/o requiring to build it
    separately.
    
    Fixes #920
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue May 26 13:06:03 2020 +0300

    configure.ac: add -fno-builtin-strcmp if valgrind is enabled
    
    Recent GCC provides strcmp which makes Valgrind assume that it accesses
    uninitialized data. Disable this optimization if Valgrind tests are
    enabled.
    
    Fixes #944
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: rrivers2 <5981058-rrivers2@users.noreply.gitlab.com>
Date:   Sun May 24 23:11:01 2020 +0000

    Update session_ticket.c to add support for zero length session tickets returned from the server
    
    check that ticket_len > 0 prior to calling gnutls_realloc_fast
    
    Signed-off-by: Rod Rivers <5981058-rrivers2@users.noreply.gitlab.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu May 14 05:54:58 2020 +0300

    build: vendor in libtasn1 code
    
    Instead of keeping the minitasn1 source in Git, vendor in it during
    bootstrap as we do with Nettle code. This also upgrades included
    minitasn1 to latest version (4.16.0).
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Steve Lhomme <robux4@ycbcr.xyz>
Date:   Tue May 19 16:23:40 2020 +0200

    win32: link with crypt32
    
    Since 5d03564cccd2c10c41252ea468d4a098bd08e9c1 we use CertOpenStore().
    To properly link it needs to be linked with the crypt32.dll.
    https://docs.microsoft.com/en-us/windows/win32/api/wincrypt/nf-wincrypt-certopenstore
    
    This library was missing from the pkg-config library. It exists in
    thirdparty_libadd to link gnutls as a DLL.
    
    Signed-off-by: Steve Lhomme <robux4@ycbcr.xyz>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue May 19 16:18:39 2020 +0200

    fips: remove FIPS_STARTUP_ONLY_TEST_CASE macro
    
    The macro was intended to avoid non-recoverable errors during library
    initialization, but the code path has been removed in commit
    3963518d067a64412bbe0aa9ce5fc33ae729c15f.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon May 18 12:25:42 2020 +0200

    fips: make FIPS140-2 mode enablement logic simpler
    
    Previously, to enable the FIPS140-2 mode, both /etc/system-fips and
    the fips=1 kernel command line need to be set.  While this was
    designed to be consistent, the convention is not well followed by the
    other crypto libraries and the former tends to be ignored.  This
    aligns the behavior to the latter, i.e. if fips=1 is set, the library
    enables the FIPS140-2 mode regardless of the existence of
    /etc/system-fips.
    
    Suggested by Alexander Sosedkin.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon May 18 00:13:34 2020 +0300

    x509: support commonName extension
    
    Add support for Common Name certificate extension.
    
    Fixes #989
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Daniel Lenski <dlenski@gmail.com>
Date:   Sun May 17 14:50:47 2020 -0700

    refine tests for ancient servers which support both SSL 3.0 and TLS 1.0, but both only with %NO_EXTENSIONS
    
    This is a follow-up to !1221.
    
    See #958 and https://gitlab.com/openconnect/openconnect/-/issues/145 for a
    real-world example of ancient Cisco servers with these deficiencies.
    
    With !1221 only, gnutls-cli-debug reports that these ancient servers only support
    SSL 3.0 (but without extensions). Information after this point is
    largely erroneous:
    
        $ gnutls-cli-debug ***vpn.***.com
        GnuTLS debug client 3.6.12
        Checking ***vpn.***.com:443
        whether the server accepts default record size (512 bytes)... no
                          whether %ALLOW_SMALL_RECORDS is required... no
                                     for SSL 3.0 (RFC6101) support... yes
                                       for SSL 3.0 with extensions... no
    
    With this additional change, gnutls-cli-debug correctly reports that such a
    server also supports TLS 1.0 (but again with extensions disabled). Below
    I've marked some of the significant fields that have changed:
    
        $ gnutls-cli-debug ***vpn.***.com
        GnuTLS debug client 3.6.12
        Checking ***vpn.***.com:443
        whether the server accepts default record size (512 bytes)... no
                          whether %ALLOW_SMALL_RECORDS is required... no
                                     for SSL 3.0 (RFC6101) support... yes
                                       for SSL 3.0 with extensions... no
                                whether we need to disable TLS 1.2... yes
                                whether we need to disable TLS 1.1... yes
        # This is now correct:
                                whether we need to disable TLS 1.0... no
        # This is now correct:
                                whether %NO_EXTENSIONS is required... yes
        # This is now correct:
                                     for TLS 1.0 (RFC2246) support... yes
                                     for TLS 1.1 (RFC4346) support... no
                                          fallback from TLS 1.1 to... failed
                                     for TLS 1.2 (RFC5246) support... no
        # This is now correct:
                            for known TLS or SSL protocols support... yes
                               TLS1.2 neg fallback from TLS 1.6 to... failed (server requires fallback dance)
                      for inappropriate fallback (RFC7507) support... no
                                             for HTTPS server name... ******
                                       for certificate chain order... sorted
                             for Safe renegotiation support (SCSV)... no
                               for version rollback bug in RSA PMS... no
                          for version rollback bug in Client Hello... no
                    whether the server ignores the RSA PMS version... no
        whether small records (512 bytes) are tolerated on handshake... yes
            whether cipher suites not in SSL 3.0 spec are accepted... yes
        whether a bogus TLS record version in the client hello is accepted... yes
                 whether the server understands TLS closure alerts... partially
                    whether the server supports session resumption... yes
                              for anonymous authentication support... no
                              for ephemeral Diffie-Hellman support... no
                                for RFC7919 Diffie-Hellman support... no
                              for AES-GCM cipher (RFC5288) support... no
                              for AES-CCM cipher (RFC6655) support... no
                            for AES-CCM-8 cipher (RFC6655) support... no
                              for AES-CBC cipher (RFC3268) support... no
                         for CAMELLIA-GCM cipher (RFC6367) support... no
                         for CAMELLIA-CBC cipher (RFC5932) support... no
        # This is now correct:
                             for 3DES-CBC cipher (RFC2246) support... yes
        # This is now correct:
                          for ARCFOUR 128 cipher (RFC2246) support... yes
                    for CHACHA20-POLY1305 cipher (RFC7905) support... no
        for GOST28147-CNT cipher (draft-smyshlyaev-tls12-gost-suites) support... no
                                               for MD5 MAC support... yes
                                              for SHA1 MAC support... yes
                                            for SHA256 MAC support... no
        for GOST28147-IMIT MAC (draft-smyshlyaev-tls12-gost-suites) support... no
    
    Signed-off-by: Daniel Lenski <dlenski@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Sun May 17 22:01:22 2020 +0300

    x509: aki: always print authorityCert info
    
    Always print authorityCertIssuer/SerialNumber. Currently it is output
    only if keyIdentifier is not present.
    
    Fixes #991
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon May 11 23:50:40 2020 +0300

    output: add Russian security class policies
    
    Add Russian Security Class certificate policies (per
    draft-deremin-rfc4491-bis).
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon May 11 23:11:56 2020 +0300

    x509: print certificate policiy names
    
    Add ability to print names for several pre-defined Certificate policies.
    Currently the list is populated with anyPolicy from X.509 and CA/B
    policies.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu May 14 02:22:05 2020 +0300

    certtool: use gnutls_pkcs7_print_signature_info
    
    Use new function to remove code duplication.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu May 14 02:20:57 2020 +0300

    pkcs7: add function to display signature information
    
    Basically export print_pkcs7_info() in a way usable by external
    applications.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu May 14 02:22:20 2020 +0300

    pkcs7: decode attribute OIDs when printing
    
    Try printing symbolic names for well-known OIDs when printing PKCS7
    signature info.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu May 14 05:28:20 2020 +0300

    devel: add libtasn1 submodule
    
    GnuTLS maintains a part of libtasn1 sources in form of minitasn1 import.
    Add libtasn1 submodule to ease synchronization with libtasn1.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu May 14 02:15:23 2020 +0300

    x509: generify oid to str conversions
    
    Make oid to name conversion functions generic enough by allowing caller
    to specify a pointer to OID table.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   Mon May 4 18:23:45 2020 +0200

    accelerated: use AES-NI for AES-XTS when available
    
    This introduces a wrapper for the CRYPTOGAMS AES-XTS implementation
    already present in the generated assembly code.
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   Fri Mar 20 16:37:33 2020 +0100

    gnutls-cli: Add option to wait for resumption data
    
    This introduces the --waitresumption command line option which makes the
    client to wait for the resumption data until a ticket is received under
    TLS1.3.  The client will block if no ticket is received.  The new option
    has no effect if the option --resume is not provided.
    
    This is useful to force the client to wait for the resumption data when
    the server takes long to send the ticket, allowing the session
    resumption to be tested.  This is a common scenario in CI systems where
    the testing machines have limited resources.
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   Tue May 5 19:27:59 2020 +0200

    benchmark: enable AES-XTS cipher
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Aug 16 17:01:05 2019 +0200

    nettle: disable RSA blinding in FIPS selftests
    
    Nettle's RSA signing, encryption and decryption functions still
    require randomness for blinding, so fallback to use a fixed buffer in
    selftests where entropy might not be available.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 26 19:27:11 2020 +0200

    nettle: expose SIV-CMAC through the AEAD interface
    
    This adds a couple of new cipher algorithms GNUTLS_CIPHER_AES_128_SIV
    and GNUTLS_CIPHER_AES_256_SIV, exposing nettle_siv_cmac_aes{128,256}*
    functions.  Note that they can only used with the AEAD interface and
    authentication tags are prepended (not appended) to the ciphertext.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 26 19:27:05 2020 +0200

    nettle: vendor in SIV-CMAC implementation
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 26 19:26:57 2020 +0200

    nettle: avoid manual backports of CFB8, CMAC, and XTS
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 26 19:26:48 2020 +0200

    nettle: rename import-chacha-from-nettle.sh to import-from-nettle.sh
    
    This script will handle other backports except ECC as well.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Apr 26 19:26:36 2020 +0200

    configure.ac: fix broken nettle_cfb8_decrypt detection
    
    Given the fixed version of the function will be part of Nettle 3.6,
    use pkg-config --atleast-version instead of a manually comparison of
    the Nettle version.
    
    Fixes #974.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Tim Rühsen <tim.ruehsen@gmx.de>
Date:   Wed Apr 29 12:41:52 2020 +0200

    New make target 'update-copyright-year'
    
    We don't want to automatically update the copyright year as this
    prevents reproducible builds.
    
    Instead, 'make update-copyright-year' has to be executed at the
    start of each new year and the changes have to be pushed.
    
    Closes #980
    
    Signed-off-by: Tim Rühsen <tim.ruehsen@gmx.de>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Wed Apr 29 20:43:23 2020 +0300

    tests/prime-check: don't include gmp.h
    
    Do not include gmp.h header, <nettle/bignum.h> conflicts with it in
    mini-gmp configuration and includes this header on it's own in
    non-mini-gmp config.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue Apr 28 17:45:40 2020 +0300

    tests/srp: increase timeouts
    
    SRP test times out if running on the GitLab CI with mini-gmp version of
    Nettle. Increase timeouts to let the test pass.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue Apr 28 15:48:29 2020 +0300

    CI: add nettle-mini-gmp test
    
    Wget/Wget2 OSS-Fuzz builders use mini-gmp version of nettle. Check that
    we do not break them occasionally.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Thu Apr 30 07:05:19 2020 +0200

    doc: expand GNUTLS_PRIVKEY_FLAG_REPRODUCIBLE description on RSA-PSS [ci skip]
    
    For RSA-PSS, this flag alone doens't fully enable reproducible
    signatures and the user needs to indicate the fact that a zero-length
    salt is used through SPKI upon verification.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue Apr 28 03:06:26 2020 +0300

    gost: use gostdsa-vko from nettle 3.6rc3
    
    Now as we have upgraded Nettle to 3.6rc3 (which includes gostdsa_vko),
    use this function from imported nettle sources.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue Apr 28 13:59:15 2020 +0300

    nettle: update imported source to nettle 3.6rc3
    
    Update imported nettle version to 3.6rc3. This will bring in updated
    gmp-glue code and a possiblity to use gostdsa-vko imported from nettle
    sources.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Apr 6 14:37:53 2020 +0200

    fips: check library soname during configure
    
    Previously, we hard-coded the sonames of linked libraries for FIPS
    integrity checking.  That required downstream packagers to manually
    adjust the relevant code in lib/fips.c, when a new interface version
    of the dependent libraries (nettle, gmp) becomes available and linked
    to libgnutls.
    
    This patch automates that process with the configure script.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Mar 27 09:53:38 2020 +0100

    gnutls_session_ext_register: keep track of extension name
    
    Previously it discarded the name argument, and that was making the
    debug output awkward, e.g., running tests/tls-session-ext-register -v:
    
      client|<4>| EXT[0x9cdc20]: Preparing extension ((null)/242) for 'client hello'
      client|<4>| EXT[0x9cdc20]: Preparing extension ((null)/241) for 'client hello'
      client|<4>| EXT[0x9cdc20]: Sending extension (null)/241 (2 bytes)
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Sun Feb 16 00:28:43 2020 +0300

    gost: update gostdsa_vko to follow Nettle
    
    Update gostdsa_vko() following changes going to be accepted into Nettle.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Apr 21 16:29:41 2020 +0200

    gnutls_ext_get_name2: new function
    
    This adds a generalized version of gnutls_ext_get_name, which can
    retrieve the name of the extension, even if it is registered per
    session.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Thu Apr 16 18:49:22 2020 +0300

    build: attempt to fix build issues on FreeBSD
    
    BSD sed does not like \n and \0 in string substitution. Workaround this
    by using sed magic.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Wed Apr 15 18:49:26 2020 +0300

    gitlab CI: when calling cppcheck ignore lib/nettle/ecc rather than lib/nettle/curve448
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue Apr 14 14:17:07 2020 +0300

    gitlab-ci: add test for usage of nettle/hogweed internal symbols
    
    Check that GnuTLS does not depend on Nettle/Hogweed internal symbols.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Tue Apr 14 13:47:43 2020 +0300

    nettle: vendor in poly1305 code
    
    Nettle's poly1305 code ended up with internal symbol _poly1305_block in
    public header. This causes issues on Nettle version changes. Since those
    symbols are going to become nettle-internal, vendor in relevant source
    file.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon Apr 13 17:54:28 2020 +0300

    gost: import _nettle_write_le32 to stop using Nettle's internal symbol
    
    Remove another dependency on nettle internal symbol by vendoring in
    _nettle_write_le32 code
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon Apr 13 17:06:06 2020 +0300

    nettle: use new imported source files for GOST DSA
    
    Provide GOST support using source files copied by script rather than
    manually crafted by me.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon Apr 13 16:11:02 2020 +0300

    build: import-curve448 -> import-ecc
    
    As the script now imports not just Curve448, but also gost code, rename
    the script, target directory and symbols to follow that.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Apr 11 15:28:29 2020 +0200

    xts: check key blocks according to FIPS-140-2 IG A.9
    
    The implementation guidance suggests that a check of key1 != key2
    should be done at any place before the keys are used:
    https://csrc.nist.gov/CSRC/media/Projects/Cryptographic-Module-Validation-Program/documents/fips140-2/FIPS1402IG.pdf
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon Apr 13 16:08:29 2020 +0300

    devel: modify curve448 script to import gost sources
    
    Curve448 script already imports several ecc sources into GnuTLS tree.
    Modify it to also vendor in GOST-related ecc files.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon Apr 13 12:43:42 2020 +0300

    import-chacha: fix several additional symbol clashes
    
    Fix sed script used to rename symbols to remove few additional symbols
    sitting in _nettle_FOO namespace.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon Apr 13 12:59:12 2020 +0300

    curve448: import write-le64.c which defines internal symbol
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Mon Apr 13 12:43:42 2020 +0300

    import-curve448: fix several additional symbol clashes
    
    Fix sed script used to rename symbols to remove few additional symbols
    sitting in _nettle_FOO namespace.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Mon Mar 30 11:27:40 2020 +0200

    handshake-tls13: add session flag to disable sending session tickets
    
    While GnuTLS by default implicitly sends NewSessionTicket during
    handshake, application protocols like QUIC set a clear boundary
    between "in handshake" and "post handshake", and NST must be sent in
    the post handshake state.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Bernhard M. Wiedemann <bwiedemann@suse.de>
Date:   Sun Apr 5 15:09:57 2020 +0200

    tests: Fix status-request-revoked after 2020-10-24
    
    included certs expire 2020-10-24 so this test fails after that date.
    
    Fixes #967
    
    This patch was done while working on reproducible builds for openSUSE.
    
    Signed-off-by: Bernhard M. Wiedemann <bwiedemann@suse.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Tue Mar 31 06:58:48 2020 +0200

    build: use valgrind client request to detect undefined memory use
    
    This tightens the check introduced in
    ac2f71b892d13a7ab4cc39086eef179042c7e23c, by using the valgrind client
    request to explicitly mark the "uninitialized but initialization is
    needed before use" regions.  With this patch and the
    fix (c01011c2d8533dbbbe754e49e256c109cb848d0d) reverted, you will see
    the following error when running dtls_hello_random_value under
    valgrind:
    
      $ valgrind ./dtls_hello_random_value
      testing: default
      ==520145== Conditional jump or move depends on uninitialised value(s)
      ==520145==    at 0x4025F5: hello_callback (dtls_hello_random_value.c:90)
      ==520145==    by 0x488BF97: _gnutls_call_hook_func (handshake.c:1215)
      ==520145==    by 0x488C1AA: _gnutls_send_handshake2 (handshake.c:1332)
      ==520145==    by 0x488FC7E: send_client_hello (handshake.c:2290)
      ==520145==    by 0x48902A1: handshake_client (handshake.c:2908)
      ==520145==    by 0x48902A1: gnutls_handshake (handshake.c:2740)
      ==520145==    by 0x402CB3: client (dtls_hello_random_value.c:153)
      ==520145==    by 0x402CB3: start (dtls_hello_random_value.c:317)
      ==520145==    by 0x402EFE: doit (dtls_hello_random_value.c:331)
      ==520145==    by 0x4023D4: main (utils.c:254)
      ==520145==
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Pierre Ossman <ossman@cendio.se>
Date:   Tue Mar 24 15:32:13 2020 +0100

    Compare DNs by comparing their string representations
    
    A binary comparison will not work in case the contents is the same but
    the ASN.1 type differ (e.g. PrintableString vs UTF8String). Such
    variations are permitted so we need to handle them.
    
    Signed-off-by: Pierre Ossman <ossman@cendio.se>

Author: Pierre Ossman <ossman@cendio.se>
Date:   Tue Mar 24 15:29:34 2020 +0100

    Properly compare DNs when checking sorting
    
    We might want to do other things than a simple memcmp() so make sure
    we're using the right helper when comparing DNs.
    
    Signed-off-by: Pierre Ossman <ossman@cendio.se>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Tue Mar 31 16:58:07 2020 +0200

    IDNA: require libidn2 2.0.0
    
    We require private symbols which dissapear at some point in
    IDN2 releases in order to support old versions of libidn2. Simplify
    the code by requiring only recent versions and avoid issues such
    as #832.
    
    Resolves: #832
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Tue Mar 31 07:40:21 2020 +0200

    NEWS: updated for release
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Mon Mar 30 20:52:36 2020 +0200

    NEWS: doc update
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Mon Mar 30 20:52:27 2020 +0200

    bumped version
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sun Mar 29 21:30:37 2020 +0200

    NEWS: doc update
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sun Mar 29 21:30:37 2020 +0200

    tests: added check for random value of client and server hello in TLS
    
    This creates a tests that checks whether the TLS client and server
    hello have sufficient non-zero bytes.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sun Mar 29 19:05:30 2020 +0200

    tests: added reproducer for client hello random value behavior in DTLS
    
    This adds an equivalent test of tls13/hello_random_value.c for DTLS
    and extends the tests for server hello as well.
    
    Relates: #960
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Mon Mar 30 08:23:03 2020 +0200

    psk: added checks to satisfy static analyzers
    
    Added null checks in legacy callbacks to avoid warnings from
    static analyzers. The issues do not appear to be reproducible
    in real-world use.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Sat Mar 28 02:31:10 2020 +0300

    padlock: fix exception in wrap_padlock_hash_fast
    
    wrap_padlock_hash_fast() allocates a context on a stack (via local
    variable) then tries to free it by calling wrap_padlock_hash_deinit()
    causing a crash. Remove a call to deinit() to fix a crash.
    
    Fixes #930
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Sat Mar 28 02:29:31 2020 +0300

    padlock: fix exception in sha code
    
    padlock sha code will segfault (at least on Nano) if it is passed a NULL
    data pointer (even if size is 0). Pass digest output buffer as a dummy
    data pointer in such case.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Sat Mar 28 02:27:31 2020 +0300

    padlock: make cbc code return error properly
    
    If underlying padlock_cbc_en/decrypt return an error, pass this error to
    calling code.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Stefan Bühler <stbuehler@web.de>
Date:   Fri Mar 27 17:17:57 2020 +0100

    dtls client hello: fix zeroed random (fixes #960)
    
    This broke with bcf4de03 "handshake: treat reply to HRR as a reply to
    hello verify request", which failed to "De Morgan" properly.
    
    Signed-off-by: Stefan Bühler <stbuehler@web.de>

Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   Tue Mar 24 09:55:08 2020 +0100

    gnutls-serv: Do not exit when a message to be echoed is received
    
    Previously, when gnutls-serv was executed with the --echo option, it
    would exit when a message to be echoed was received.  Moreover, the
    server would output "Memory error" although no error occurred.
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Wed Mar 18 11:23:47 2020 +0100

    _gnutls_check_id_for_change: ensure that we check the username length
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Wed Mar 18 10:01:53 2020 +0000

    Ensure that an incorrectly formatted password file doesn't cause invalid memory access
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Ander Juaristi <a@juaristi.eus>
Date:   Sun Mar 15 23:31:49 2020 +0100

    Update NEWS file
    
    Signed-off-by: Ander Juaristi <a@juaristi.eus>

Author: Ander Juaristi <a@juaristi.eus>
Date:   Tue Mar 3 11:49:32 2020 +0000

    Update files
    
    Signed-off-by: Ander Juaristi <a@juaristi.eus>

Author: Ander Juaristi <a@juaristi.eus>
Date:   Mon Mar 2 16:37:10 2020 +0100

    psk: Allow non-NULL PSK usernames
    
    This commit closes #586.
    
    Two new functions are introduced: gnutls_psk_server_get_username2()
    and gnutls_psk_set_client_username2(), which are identical in behavior
    to those named similarly (without the final '2'), but allow arbitrary
    gnutls datums (not strings) to be used as usernames.
    
    Two new callback functions are also introduced, with their respective
    setters: gnutls_psk_set_server_credentials_function2() and
    gnutls_psk_set_client_credentials_function2().
    
    In addition, the password file format is extended so that non-string
    usernames can be specified. A leading '#' character tells GnuTLS that the
    username should be interpreted as a raw byte string (encoded in HEX).
    
    Example:
    
        #deadbeef:9e32cf7786321a828ef7668f09fb35db
    
    Signed-off-by: Ander Juaristi's avatarAnder Juaristi <a@juaristi.eus>

Author: Daniel Lenski <dlenski@gmail.com>
Date:   Sun Mar 22 19:12:44 2020 -0700

    add NEWS entry
    
    Signed-off-by: Daniel Lenski <dlenski@gmail.com>

Author: Daniel Lenski <dlenski@gmail.com>
Date:   Sun Mar 22 19:01:55 2020 -0700

    add additional tests of SSL 3.0 (with extensions, and with cipher suites not in SSL 3.0)
    
    See #958
    
    Signed-off-by: Daniel Lenski <dlenski@gmail.com>

Author: Daniel Lenski <dlenski@gmail.com>
Date:   Sun Mar 22 19:00:32 2020 -0700

    test_ssl3: minimize cipher suites to those actually included in SSL 3.0
    
    See #958
    
    Signed-off-by: Daniel Lenski <dlenski@gmail.com>

Author: Daniel Lenski <dlenski@gmail.com>
Date:   Sun Mar 22 18:58:26 2020 -0700

    SSL 3.0 (RFC6101) doesn't actually appear to require extensions, and some servers don't accept them
    
    See #958
    
    Signed-off-by: Daniel Lenski <dlenski@gmail.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Mar 22 10:44:51 2020 +0100

    gnutls_session_get_keylog_function: new function
    
    This adds a way to retrieve the keylog function set by
    gnutls_session_set_keylog_function() to allow application protocols to
    implement custom logging facility.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Sun Mar 22 16:07:12 2020 +0300

    oss-fuzz: return build error if fuzzers have failed to build
    
    Instead of silently ignoring build errors and running fewer fuzzers,
    exit on the first build error.
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Dmitry Baryshkov <dbaryshkov@gmail.com>
Date:   Sun Mar 22 16:05:40 2020 +0300

    oss-fuzz: use CC rather than CXX to compile fuzzers
    
    clang++ will choke on several fuzzer sources because C++ is stricter
    than C wrt. type conversion:
    
    gnutls_base64_decoder_fuzzer.c:26:63: error: non-constant-expression
    cannot be narrowed from type 'size_t' (aka 'unsigned long') to 'unsigned
    int' in initializer list [-Wc++11-narrowing]
            gnutls_datum_t raw = {.data = (unsigned char *)data, .size = size};
    
    Signed-off-by: Dmitry Baryshkov <dbaryshkov@gmail.com>

Author: Tim Rühsen <tim.ruehsen@gmx.de>
Date:   Thu Mar 19 17:49:11 2020 +0100

    fuzz: Update README.md for clang-9 [skip ci]
    
    Signed-off-by: Tim Rühsen <tim.ruehsen@gmx.de>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sun Mar 15 11:18:30 2020 +0100

    state: add function to get the current hash algorithm
    
    This is particularly useful when the application applies key
    derivation function by itself with the same underlying hash algorithm
    as the session.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Mar 14 09:53:31 2020 +0100

    abi: add enum values for GNUTLS_CIPHER_CHACHA20_*
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Mar 14 06:09:56 2020 +0100

    cipher: allow setting ChaCha20 initial block counter
    
    This also introduces GNUTLS_CIPHER_CHACHA20_32, which is a 96-bit
    nonce variant of GNUTLS_CIPHER_CHACHA20_64.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Fri Mar 13 17:24:26 2020 +0100

    nettle: vendor in ChaCha20 implementation from nettle
    
    This enables to use bundled ChaCha20 implementation if the system
    nettle doesn't have nettle_chacha_set_counter.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Daiki Ueno <ueno@gnu.org>
Date:   Sat Mar 14 06:01:49 2020 +0100

    cipher: expose raw ChaCha20 cipher
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   Wed Mar 18 16:17:39 2020 +0100

    global: Load configuration after FIPS POST
    
    Previously, if the loaded configuration file disabled an algorithm
    tested during FIPS-140 power-on self-tests, the test would fail.  By
    loading the configuration file after the test is finished, such failure
    is avoided as any algorithm is allowed during the tests.
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

Author: Jakub Jelen <jjelen@redhat.com>
Date:   Wed Mar 11 18:31:49 2020 +0100

    Validate EC_PARAMS for EdDSA keys
    
    Signed-off-by: Jakub Jelen <jjelen@redhat.com>

Author: Jakub Jelen <jjelen@redhat.com>
Date:   Fri Mar 6 13:41:25 2020 +0100

    pubkey: Validate input parameters in pubkey_import_ecc_raw
    
    Signed-off-by: Jakub Jelen <jjelen@redhat.com>

Author: Jakub Jelen <jjelen@redhat.com>
Date:   Fri Feb 28 18:50:53 2020 +0100

    tests: Verify writing and reading of ECDSA public keys from PKCS#11
    
    Signed-off-by: Jakub Jelen <jjelen@redhat.com>

Author: Jakub Jelen <jjelen@redhat.com>
Date:   Fri Feb 28 18:45:14 2020 +0100

    tests: Verify writing and reading of EdDSA public keys
    
    Signed-off-by: Jakub Jelen <jjelen@redhat.com>

Author: Jakub Jelen <jjelen@redhat.com>
Date:   Fri Feb 28 18:40:42 2020 +0100

    pkcs11_write: Copy data to avoid double-free crashes and properly encode EC_POINT attribute
    
    Signed-off-by: Jakub Jelen <jjelen@redhat.com>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sat Mar 14 23:15:45 2020 +0100

    .lgtm.yml: work around issues in LGTM system
    
    This disables dependency tracking and removes the gnulib
    tests to work-around a failure build gl/.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Thu Mar 12 20:46:58 2020 +0100

    bootstrap.conf: do not bring tests in gnulib clones (src/unistring)
    
    These tests are not being run, and they can cause issues as
    in !1208.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Nikos Mavrogiannopoulos <nmav@gnutls.org>
Date:   Sat Mar 14 22:39:05 2020 +0100

    .lgtm.yml: no longer bring nettle from master
    
    The system used has already a sufficiently recent version.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@gnutls.org>

Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   Thu Apr 4 15:45:02 2019 +0200

    crypto-selftests-pk.c: Use deterministic signatures in test_known_sig()
    
    Use deterministic signatures for ECDSA and DSA in test_known_sig().  Do
    not call test_known_sig() for non-deterministic algorithms.  Do not run
    PK_TEST() for algorithms tested with PK_KNOWN_TEST().
    
    The deterministic algorithms are used if in FIPS-140 POST or if FIPS-140
    mode is disabled.  When called explicitly with FIPS-140 mode enabled,
    the pairwise-consistency test (PK_TEST()) is used instead.
    
    test_known_sig() was modified to support only deterministic algorithms.
    The "deterministic" parameter was replaced with the "flags" parameter
